;	M4CMD/ASM
;	JUMPING TO THIS LOCATION IS LIKE RETSKP.  IT ASSUMES THE INSTRUCTION
;	AFTER THE CALL IS A JMP ADDR.
RSKP	POP    HL		;GET THE RETURN ADDRESS.
	INC    HL		;INCREMENT BY THREE.
	INC    HL
	INC    HL
	JP   (HL)  
;THIS ROUTINE PRINTS THE NUMBER IN HL ON THE SCREEN IN DECIMAL.
;SAVES ALL ACS.
NOUT	PUSH   AF		;SAVE OUR ACS.
	PUSH   BC
	PUSH   DE
	PUSH   HL
	LD	A,97		;@HEXDEC SVC VALUE
	LD	DE,NBUFF	;WHERE TO PUT THE NUMBER
	RST	28H
	EX	DE,HL		;HL = BUFFER+1
	LD	(HL),'$'	;TERMINATOR FOR PRINT ROUTINE
	LD	HL,NBUFF	;RESTORE ADDRESS OF BUFFER
	LD	A,' '
NOUT1	CP	(HL)		;FIND FIRST NON-BLANK
	JR	NZ,NOUT2	;GO WHEN WE DO
	INC	HL		;POINT AT NEXT CHARACTER
	JR	NOUT1		;LOOP ON
NOUT2	EX	DE,HL		;DE IS THE ADDRESS NOW FOR PRINTING
	CALL	PRTSTR		;PRINT THE NUMBER
	POP    HL		;RESTORE THE ACS.
	POP    DE
	POP    BC
	POP    AF
	RET    
NBUFF	DEFS	6
;	THIS SET OF ROUTINES PROVIDES A USER ORIENTED WAY OF PARSING
;	COMMANDS.  IT IS SIMILAR TO THAT OF THE COMND JSYS IN TOPS-20.
;	THIS ROUTINE PRINTS THE PROMPT IN DE AND SPECIFIES THE REPARSE
;	ADDRESS
PROMPT	POP    HL		;GET THE RETURN ADDRESS.
	PUSH   HL		;PUT IT ON THE STACK AGAIN.
	LD     (CMRPRS),HL	;SAVE IT AS THE ADDRESS TO GO TO ON REPARSE.
	LD     (CMOSTP),SP	;SAVE FOR LATER RESTORAL.
	LD     (CMPRMP),DE	;SAVE THE PROMPT LOCATION
	LD     HL,CMDBUF
	LD     (CMCPTR),HL	;INITIALIZE THE COMMAND POINTER.
	LD     (CMDPTR),HL
	XOR    A
	LD     (CMAFLG),A	;ZERO THE FLAGS.
	LD     (CMCCNT),A
	LD     A,0FFH		;TRY IT THIS WAY (DAPHNE.)
	LD     (CMSFLG),A
	LD	A,(TAKFLG)	;CHECK IF TAKE ACTIVE
	OR	A
	JR	Z,PRMT10	;GO IF IT ISN'T
	LD	A,(TAKLOG)	;IS TAKE DISPLAY ACTIVE?
	OR	A
	JR	Z,PRMT20	;GO IF IT ISN'T
PRMT10	CALL	NEWLIN
	LD     DE,(CMPRMP)	;PRINT THE PROMPT.
	CALL   PRTSTR
PRMT20	RET    
;	THIS ADDRESS IS JUMPED TO ON REPARSE.
REPARS	LD     SP,(CMOSTP)	;GET THE OLD STACK POINTER.
	LD     HL,CMDBUF
	LD     (CMDPTR),HL
	LD     A,0FFH		;TRY IT THIS WAY (DAPHNE.)
	LD     (CMSFLG),A
	LD     HL,(CMRPRS)	;GET THE REPARSE ADDRESS.
	JP   (HL)		;GO THERE.
;	THIS ADDRESS CAN BE JUMPED TO ON A PARSING ERROR.
PRSERR	LD     SP,(CMOSTP)	;GET THE OLD STACK POINTER.
	LD     HL,CMDBUF
	LD     (CMCPTR),HL	;INITIALIZE THE COMMAND POINTER.
	LD     (CMDPTR),HL
	CALL	NEWLIN
	XOR    A
	LD     (CMAFLG),A	;ZERO THE FLAGS.
	LD     (CMCCNT),A
	LD     A,0FFH		;TRY IT THIS WAY (DAPHNE.)
	LD     (CMSFLG),A
	LD     DE,(CMPRMP)	;GET THE PROMPT.
	CALL   PRTSTR
;* INSTEAD RETURN TO BEFORE THE PROMPT CALL.
	LD     HL,(CMRPRS)
	JP   (HL)  
;	THIS ROUTINE PARSES THE SPECIFIED FUNCTION IN A.  ANY ADDITIONAL
;	INFORMATION IS IN DE AND HL.
;	RETURNS +4 ON SUCCESS
;		+1 ON FAILURE (ASSUMES A JMP FOLLOWS THE CALL)
COMND	LD     (CMSTAT),A	;SAVE WHAT WE ARE PRESENTLY PARSING.
	CALL   CMINBF		;GET CHARS UNTIL AN ACTION OR A ERASE CHAR.
	CP	CMNUM		;IS IT A DECIMAL NUMBER?
	JP	Z,CMDNUM	;GO GET ONE
	CP     CMCFM		;PARSE A CONFIRM?
	JP     Z,CMCFRM		;GO GET ONE.
	CP     CMKEY		;PARSE A KEYWORD?
	JP     Z,CMKEYW		;TRY AND GET ONE.
	CP     CMIFI		;PARSE AN INPUT FILE SPEC?
	JP     Z,CMIFIL		;GO GET ONE.
	CP     CMIFIN		;INPUT FILE-SPEC SILENT?
	JP     Z,CMIFIL		;DO AS HE WISHES
	CP     CMOFI		;OUTPUT FILE SPEC?
	JP     Z,CMIFIL		;GO GET ONE.
	CP     CMTXT		;PARSE ARBITRARY TEXT?
	JP     Z,CMTEXT		;GO DO IT.
	LD     DE,CMER00	;"?UNRECOGNIZED COMND CALL"
	CALL   PRTSTR
	RET    
;	THIS ROUTINE PARSES ARBITRARY TEXT UP TO A CR.
;	ACCEPTS DE	ADDRESS TO PUT TEXT
;	RETURNS IN A	NUMBER OF CHARS IN TEXT (MAY BE 0)
;		  DE	UPDATED POINTER
CMTEXT	EX   DE,HL   		;PUT THE POINTER TO THE DEST IN HL.
	LD     (CMPTAB),HL	;SAVE THE POINTER.
	LD     B,0		;INIT THE CHAR COUNT
CMTXT1	CALL   CMGTCH		;GET A CHAR.
	OR     A		;TERMINATOR?
	JP     P,CMTXT5		;NO, PUT IN USER SPACE.
	AND    7FH		;TURN OFF MINUS BIT.
	CP     ESC		;AN ESCAPE?
	RET	Z
CMTXT2	CP	'?'		;DO THEY NEED HELP?
	JR	Z,CMTXT7	;JUMP IF THEY DO
	CP	' '	 	;BLANK?
	JR	Z,CMTXT5	;IF SO PUT IN THE TEXT
	CP     FF		;IS IT A FORMFEED?
	CALL   Z,CMBLNK		;IF SO BLANK THE SCREEN.
	LD     A,B		;RETURN THE COUNT.
	LD     HL,(CMPTAB)	;RETURN UPDATED POINTER IN HL.
	LD	(HL),CR		;PUT IN THE TERMINATOR
	EX   DE,HL   
	JP     RSKP		;RETURN SUCCESS.
CMTXT3	LD     HL,CMAFLG	;POINT TO THE ACTION FLAG.
	LD     (HL),0		;SET IT TO ZERO.
CMTXT5	INC    B		;INCREMENT THE COUNT.
CMTXT6	LD     HL,(CMPTAB)	;GET THE POINTER.
	LD     (HL),A		;PUT THE CHAR IN THE ARRAY.
	INC    HL
	LD     (CMPTAB),HL	;SAVE THE UPDATED POINTER.
	JR     CMTXT1		;GET ANOTHER CHAR.
CMTXT7	LD	DE,TXTHLP	;HELP MESSAGE INTO DE
	CALL	REPRNT		;PRINT THE MESSAGE AND THE PROMPT
	JP	REPARS		;GET SOMEMORE INPUT
;THIS ROUTINE PARSES AN INPUT NUMBER IN ASCII DECIMAL
THEVAL	DW	0
CMDNUM	LD	B,0		;NO CHARACTERS YET
	LD	HL,0		;SET VALUE TO ZERO FIRST
	LD	(THEVAL),HL
CMNM10	CALL	CMGTCH		;GET A CHARCTER
	OR	A		;IS IT A TERMINATOR?
	JP	P,CMNM50	;GO IF NOT
	AND	7FH		;MAKE IT NORMAL
	CP	ESC		;IS IT ABORT?
	RET	Z		;TAKE THE ERROR EXIT
CMNM20	CP	'?'		;IS THE USER CURIOUS?
	JR	Z,CMNM70	;GO IF SO
	CP	12		;IS IT A FORMFEED
	CALL	Z,CMBLNK	;CLEAR THE SCREEN IF NECESSARY
	LD	A,B		;GET COUNT OF CHARACTERS
	LD	DE,(THEVAL)	;GET THE NUMBER FOUND
	JP	RSKP		;RETURN WITH VALUE IN DE
CMNM50	INC	B
	PUSH	HL		;SAVE HL FOR THE MULTIPLY
	PUSH	DE
	PUSH	BC
	LD	HL,(THEVAL)	;GET THE CURRENT NUMBER
	LD	C,10		;TIMES 10
	PUSH	AF
	LD	A,91		;@MUL16 SVC
	RST	28H
	LD	H,L		;SHIFT ALL INTO HL
	LD	L,A		;GET LSB IN L
	POP	AF		;RESTORE WHAT TO ADD
	SUB	48		;CHECK FOR A NUMBER
	JP	P,CMNM60	;OK SO FAR
CMNM55	POP	BC		;RESTORE THE REGS
	POP	DE
	POP	HL
	LD	DE,ERMES2	;SAY BAD CHARACTER
	CALL	PRTSTR
	JP	KERMIT		;GET A NEW COMMAND
CMNM60	CP	10		;CHECK SOME MORE
	JP	P,CMNM55	;ABORT ON 10 OR LARGER
	LD	C,A		;GET IT INTO BC FOR 16 BIT MATH
	LD	B,0		;ZERO MSB
	ADD	HL,BC		;COMPUTE THE NEW NUMBER
	LD	(THEVAL),HL
	POP	BC
	POP	DE
	POP	HL
	JR	CMNM10
CMNM70	LD	DE,NUMHLP
	CALL	REPRNT		;PRINT THE PROMPT AND REPARSE
	JP	REPARS
;THIS ROUTINE GETS A CONFIRM.
CMCFRM	CALL	CMGTCH		;GET A CHARACTER FROM THE BUFFER
	OR	A		;WHAT WAS IT, CONTROL?
	RET	P		;NOPE, SO EXIT VIA ERROR RETURN
	AND	7FH		;STRIP THE SIGN BIT FLAG
	CP	'?'		;STILL ASKING FOR HELP?
	JR	NZ,CMCFR3	;NOPE, SO REACT
	LD	DE,CMIN00	;TELL THEM NO MORE HELP
	CALL	REPRNT		;PRINT THE MESSAGE
	JP	REPARS		;PRINT THE MESSAGE AND THE PROMPT AGAIN
CMCFR3	CP	ESC		;IS IT ABORT?
	RET	Z		;TAKE ERROR EXIT IF SO
	CP	12		;WHAT IS THIS FOR GUYS?
	CALL	Z,CMBLNK
	JP	RSKP		;TAKE NORMAL RETURN
;	THIS ROUTINE PRINTS THE MESSAGE IN DE AND SETS UP FOR A REPARSE
REPRNT	CALL   PRTSTR
	XOR	A
	LD	(CMAFLG),A
	CALL	NEWLIN
	LD	DE,(CMPRMP)
	CALL	PRTSTR
	LD	HL,(CMCPTR)
	DEC	HL
	LD	(HL),'$'
	LD	(CMCPTR),HL
	LD	DE,CMDBUF
	CALL	PRTSTR
	RET
;	THIS ROUTINE PARSES A KEYWORD FROM THE TABLE POINTED
;	TO IN DE.  THE FORMAT OF THE TABLE IS AS FOLLOWS
;
;	ADDR	DB    N         WHERE N IS THE # OF ENTRIES IN THE TABLE.
;		DB    M	       M IS THE SIZE OF THE KEYWORD.
;		DB    'STRING$' WHERE STRING IS THE KEYWORD.
;		DB    A,B       WHERE A & B ARE PIECES OF DATA
;			         TO BE RETURNED.  (MUST BE TWO OF THEM.)
;
;	THE KEYWORDS MUST BE IN ALPHABETICAL ORDER.
;**** NOTE  THE DATA VALUE A IS RETURNED IN REGISTERS A AND E.  THE
;****	DATA VALUE B IS RETURNED IN REGISTER D.  THIS ALLOWS THE TWO DATA
;	BYTES TO BE STORED AS
;		DW	XXX
;	AND RESULT IN A CORRECTLY FORMATTED 16-BIT VALUE IN REGISTER PAIR
;	DE.
CURLEN	DB	0
MAXLEN	DB	0
CMKEYW	LD	(CMPTAB),DE	;SAVE THE BEGINNING OF KEYWORD TAB FOR '?'.
	LD	A,(DE)		;GET THE NUMBER OF ENTRIES IN THE TABLE.
	LD	B,A		;SAVE IN B
	INC	DE
	INC	DE		;POINT PAST THE MAX LENGTH NUMBER
	LD	(CMKPTR),DE
	LD	HL,(CMDPTR)	;SAVE THE COMMAND POINTER.
	LD	(CMSPTR),HL
CMKEY2	LD	A,B
	OR	A		;ANY LEFT?
	RET	Z		;IF NOT WE FAILED.
	LD	HL,(CMKPTR)
	LD	E,(HL)		;GET THE LENGTH OF THE KEYWORD.
	INC	HL
CMKEY3	DEC	E		;DECREMENT THE NUMBER OF CHARS LEFT.
	LD	A,E
	CP	0FFH		;HAVE WE PASSED THE END?
	JP	M,CMKEY5	;IF SO GO TO THE NEXT.
	CALL	CMGTCH		;GET A CHAR.
	OR	A		;IS IT A TERMINATER?
	JP	P,CMKEY4	;IF POSITIVE, IT IS NOT.
	AND	7FH		;TURN OFF THE MINUS BIT.
	CP	'?'
	JP	NZ,CMKY35
	PUSH	HL		;SAVE HL FOR A SEC
	PUSH	DE
	CALL	CMAMBG		;ARE WE QUALIFIED AT THE '?' ?
	JP	CMKY30		;WE WERE NOT AMBIGUOUS IF RETURN HERE
	XOR	A
	LD	(CMAFLG),A	;TURN OFF THE ACTION FLAG.
	LD	DE,HLPMES	;PRINT ONE OF THE FOLLOWING...
	CALL	PRTSTR
	LD	HL,CMCCNT	;DECREMENT THE CHAR COUNT.
	DEC	(HL)
	POP	DE
	POP	HL
	LD	HL,(CMPTAB)	;GET THE START OF THE KEYWORD TABLE
	LD	B,(HL)		;B IS HOW MANY IN THE TABLE
	INC	HL		;POINT AT THE FIRST ENTRY
	LD	A,(HL)		;GET THE COLUMN SPACING VALUE
	LD	(MAXLEN),A	;SAVE IT FOR LATER
	INC	HL		;POINT AT THE FIRST ENTRY
CM1010	LD	C,(HL)		;C IS HOW MANY CHARACTERS IN NAME
	LD	A,C		;SAVE THE LENGTH FOR LATER
	LD	(CURLEN),A
	INC	HL		;POINT AT THE TEXT FOLLOWING
	LD	(CMKPTR),HL	;SAVE THE ADDRESS TO PRINT FROM ON A MATCH
	LD	DE,(CMSPTR)	;GET THE ADDRESS OF THE KEYWORD TO MATCH
CM1020	LD	A,(DE)		;GET A CHARACTER
	CP	'?'		;IS THE USER CURIOUS?
	JR	Z,CM1040	;GO HELP THEM IF THEY ARE
	CALL	CAPTAL		;MAKE SURE LETTERS ARE UPPER CASE
	INC	DE		;POINT TO THE NEXT.
	CP	(HL)		;SAME AS IN KEYWORD TABLE?
	INC	HL		;POINT TO THE NEXT
	JR	NZ,CM1050	;JUMP IF NO MATCH
	DEC	C		;ONE LESS CHARACTER IN THE KEYWORD
	JR	NZ,CM1020	;TRY SOME MORE
	JP	CM1190		;GOTO NOT AMBIGUOUS
CM1040	PUSH	DE		;SAVE THE REGS
	PUSH	HL
	PUSH	BC
	LD	B,4		;GET THE CURRENT COLUMN
	CALL	XVDCTL		;THE COLUMN IS IN L
	PUSH	HL		;SAVE THE ROW AND THE COLUMN
	LD	A,(MAXLEN)	;GET THE COLUMN SPACING
	ADD	A,L		;CALCULATE THE NEW PLACE
	CP	79		;ARE WE PAST THE EDGE
	JP	M,CM1043	;GO IF NOT
	POP	HL		;THROW AWAY THE OLD ROW
	CALL	NEWLIN		;GET A NEW LINE IF BEYOND THE END
	LD	B,4		;GET ROW & COLUMN OPTION
	CALL	XVDCTL		;GET THE NEW ROW AND COL
	PUSH	HL		;SAVE IT FOR LATER
	LD	A,(MAXLEN)	;GET THE NEW POSITION AS JUST THE LENGTH
CM1043	PUSH	AF
	LD	DE,(CMKPTR)	;GET THE KEYWORD TO PRINT
	CALL	PRTSTR		;PRINT IT
	POP	AF
	POP	HL
	LD	L,A		;SET THE NEW COLUMN
	LD	B,3		;SELECT SET ROW, COLUMN
	CALL	XVDCTL		;SET IT
	POP	BC		;RESTORE THE REGS
	POP	HL
	POP	DE
CM1045	LD	A,3		;SKIP OVER THE $ AND THE DISCRIPTOR
	ADD	A,C		;PLUS THE CHARACTERS LEFT IN THE STRING
	LD	E,A		;PUT IT IN DE TO ADD
	LD	D,0		;MAKE IT A BYTE VALUE IN 16 BITS
	ADD	HL,DE		;GOT THE NEW ADDRESS
	DJNZ	CM1010		;GET THE NEXT
	JR	CM1190		;END OF THE TABLE
CM1050	DEC	HL		;CORRECT HL FROM LAST INCREMENT
	JP	P,CM1045	;IF (TABLE) > (COMMAND) KEEP LOOKING
	XOR	A		;RESET THE ACTION FLAG
	LD	(CMAFLG),A
CM1190	CALL	NEWLIN		;PRINT A NEW LINE
CM1200	CALL	NEWLIN		;PRINT A NEW LINE
	LD	DE,(CMPRMP)	;GET THE PROMPT TO REPRINT
	CALL	PRTSTR		;PRINT IT
	LD	HL,(CMDPTR)	;GET THE END OF THE COMMAND LINE
	LD	(HL),'$'	;TERMINATOR FOR PRINTING
	LD	HL,(CMCPTR)	;GET THE LAST CHARACTER
	DEC	HL
	LD	(CMCPTR),HL	;IGNORE THE '?' AT THE END
	LD	DE,CMDBUF	;GET THE START OF THE BUFFER
	CALL	PRTSTR		;PRINT THE COMMAND LINE
	JP	REPARS		;REPARSE THE ENTIRE LINE
;	THIS CODE COMPLETES A UNABIGUOUS COMMAND THAT WAS TERMINATED
;	BY A '?'.  HL IS ON THE STACK, AND CONTAINS THE FIRST CHARACTER
;	OF THE KEYWORD, THAT WAS NOT TYPED ON THE COMMAND LINE.
;	CMDPTR IS WHERE IN THE BUFFER WE WILL ADD THE CHARACTERS.
CMKY30	EXX			;OTHER REGS
	POP	DE		;REMOVE DE TO GET HL
	POP	HL		;GET HL
	PUSH	HL		;RESTORE HL TO THE STACK
	PUSH	DE		;SAME FOR DE
	LD	DE,(CMDPTR)	;GET THE END OF THE COMMAND LINE
CM3010	LD	A,(HL)		;GET A CHARACTER FROM THE TABLE
	CP	'$'		;END OF THE KEYWORD?
	JR	Z,CM3020	;STOP
	LD	(DE),A		;ADD THE CHARACTER TO THE COMMAND LINE
	INC	HL
	INC	DE
	JR	CM3010		;GO SOME MORE
CM3020	LD	A,' '		;END WITH A SPACE FOR SEPARATION
	LD	(DE),A		;PUT IN THE SPACE
	INC	DE		;WHERE TO PUT NEXT CHAR IN BUFFER
	LD	A,'?'		;GET READY FOR THE REPARSE
	LD	(DE),A
	LD	(CMDPTR),DE	;SAVE THE NEW POINTER
	INC	DE
	LD	(CMCPTR),DE
	EXX			;RESTORE THE OLD REGS
	JR	CMKY36		;JOIN THE OTHER CODE
CMKY32	LD     HL,(CMCPTR)	;POINTER INTO BUFFER.
	DEC    HL		;BACKUP TO THE ESCAPE.
	EX   DE,HL   
	POP    HL
	PUSH   HL
CMKY33	LD     A,(HL)		;GET THE NEXT CHAR.
	CP     '$'		;FINISHED?
	JP     Z,CMKY34
	INC    HL
	EX   DE,HL   
	LD     (HL),A		;MOVE IT INTO THE BUFFER.
	INC    HL
	EX   DE,HL   
	LD     A,(CMCCNT)	;INCREMENT THE CHAR COUNT.
	INC    A
	LD     (CMCCNT),A
	JR	CMKY33
CMKY34	LD     A,(CMCCNT)	;GET THE CHARACTER COUNT.
	INC    A		;INCREMENT AND SAVE IT.
	LD     (CMCCNT),A
	EX   DE,HL   		;PUT THE COMMAND BUFFER POINTER IN HL.
	LD     (HL),' '		;PUT IT IN THE COMMAND BUFFER.
	INC    HL		;INCREMENT THE POINTER
	LD     (CMCPTR),HL	;SAVE THE UPDATED POINTER.
	LD     (CMDPTR),HL
	POP    HL
	PUSH   HL
	EX   DE,HL   
	CALL   PRTSTR		;PRINT THE REST OF THE KEYWORD.
	LD     A,' '
	CALL	CONOUT
	POP    HL
	POP    BC
	POP    DE
	JP     CMKY37
CMKY35	CP	ESC
	RET	Z
	PUSH   HL
	PUSH   DE
	CALL   CMAMBG
	JP	CMKY36
	LD	HL,(CMCPTR)	;GET THE END OF THE COMMAND
	LD	BC,CMDBUF	;GET THE START OF THE BUFFER
	OR	A		;RESET THE CARRY
	SBC	HL,BC		;COMPUTE THE OFFSET
	LD	DE,CMER01
	CALL   NZ,PRTSTR	;SAY ITS AMBIGUOUS.
	JP     PRSERR		;GIVE UP.
CMKY36	POP    DE
	POP    HL
CMKY37	INC    E		;ADD ONE INCASE IT IS NEGATIVE.
	LD     D,0
	ADD    HL,DE		;INCREMENT PAST THE KEYWORD.
	INC    HL		;PAST THE $.
	LD     E,(HL)		;GET THE DATA.
	INC    HL
	LD     D,(HL)
	LD     A,E
	JP     RSKP
CMKEY4	CALL	CAPTAL		;MAKE IT UPPER CASE IF LOWER	
CMKY41	LD     D,(HL)		;GET THE NEXT CHAR OF THE KEYWORD.
	INC    HL
	CP     D		;MATCH?
	JP     Z,CMKEY3		;IF SO GET THE NEXT LETTER.
CMKEY5	LD     D,0
	LD     A,E		;GET THE NUMBER OF CHARS LEFT.
	OR     A		;IS IT NEGATIVE?
	JP     P,CMKY51
	LD     D,0FFH		;IF SO, SIGN EXTEND.
CMKY51	ADD    HL,DE		;INCREMENT PAST THE KEYWORD.
	INC	HL		;PLUS 3
	INC	HL
	INC	HL
	LD     (CMKPTR),HL
	DEC    B		;DECREMENT THE NUMBER OF ENTRIES LEFT.
	LD     HL,(CMSPTR)	;GET THE OLD CMDPTR.
	LD     (CMDPTR),HL	;RESTORE IT.
	JP     CMKEY2		;GO CHECK THE NEXT KEYWORD.
;	CONVERT CONTENTS OF A TO UPPER CASE IF IT IS LOWER
CAPTAL	CP	'a'		;IS IT LOWER CASE
	JR	C,CAPS10	;MIGHT BE
	CP	'z'		;IS IT BIGGER THAN 'z'
	JR	NC,CAPS10	;GO IF IT IS
	AND	137O		;MAKE IT UPPER CASE
CAPS10	RET			;RETURN TO THE CALLER
;	CHECK AMBIGUITY OF A COMMAND
CMAMBG	DEC    B		;DECREMENT THE NUMBER OF ENTRIES LEFT.
	RET   M			;IF NONE LEFT THEN IT IS NOT AMBIGUOUS.
	INC    E		;THIS IS OFF BY ONE; ADJUST.
	LD     C,E		;SAVE THE CHAR COUNT.
	LD     A,E
	OR     A		;ANY CHARS LEFT?
	RET   Z			;NO, IT CAN'T BE AMBIGUOUS.
	LD     D,0
	ADD    HL,DE		;INCREMENT PAST THE KEYWORD.
	LD     E,3		;PLUS THE $ AND DATA.
	ADD    HL,DE
	LD     B,(HL)		;GET THE LENGTH OF THE KEYWORD.
	INC    HL
	EX   DE,HL   
	LD     HL,(CMKPTR)	;GET POINTER TO KEYWORD ENTRY.
	LD     A,(HL)		;GET THE LENGTH OF THE KEYWORD.
	SUB    C		;SUBTRACT HOW MANY LEFT.
	LD     C,A		;SAVE THE COUNT.
	CP     B
	JP     Z,CMAMB0
	RET   P			;IF LARGER THAN THE NEW WORD THEN NOT AMB.
CMAMB0	LD     HL,(CMSPTR)	;GET THE POINTER TO WHAT PARSED.
CMAMB1	DEC    C		;DECREMENT THE COUNT.
	JP     M,RSKP		;IF WE ARE DONE THEN IT IS AMBIGUOUS.
	EX   DE,HL		;EXCHANGE THE POINTERS.
	LD     B,(HL)		;GET THE NEXT CHAR OF THE KEYWORD
	INC    HL
	EX   DE,HL		;EXCHANGE THE POINTERS.
	LD     A,(HL)		;GET THE NEXT PARSED CHAR.
	INC    HL
	CALL	CAPTAL		;MAKE IT UPPER IF LOWER
CMAMB2	CP     B		;ARE THEY EQUAL?
	RET   NZ		;IF NOT THEN ITS NOT AMBIGUOUS.
	JP     CMAMB1		;CHECK THE NEXT CHAR.
CMIFIL	LD	(CMFCB),DE	;SAVE WHERE TO PUT THE CHARACTERS
	LD	HL,CLBUF	;GET THE INTERMEDIATE BUFFER
	LD	B,80		;NUMBER OF PLACES TO FILL
CMIFI0	LD     (HL),CR		;FILL THE FCB.
	INC    HL
	DJNZ	CMIFI0
	LD	DE,CLBUF
CMIFI1	CALL	CMGTCH		;GET A CHARACTER
	OR	A		;CHECK FOR A CONTROL CHARACTER ?,CR,ESC
	JP	P,CMIFI3	;GO IF NOT CONTROL
	AND	7FH		;STRIP THE HIGH BIT
	CP	ESC		;WAS IT ABORT?	
	RET	Z		;TAKE THE ERROR EXIT
	CP	'?'		;WAS IT HELP?
	JR	NZ,CMIFI4	;GO IF NOT
	LD	DE,FILHLP	;PRINT A MESSAGE
	CALL	REPRNT		;SET UP FOR REPARSE
	JP	REPARS		;GET A NEW CHARACTER
CMIFI3	LD	(DE),A		;STORE THE CHARACTER
	INC	DE		;POINT TO NEXT POS
	INC	B		;INCREMENT CHARACTER COUNT
	JR	CMIFI1		;GET ANOTHER ONE
CMIFI4	LD	A,B		;GET THE COUNT
	OR	A
	RET	Z
	PUSH	HL		;SAVE HL
	PUSH	BC		;SAVE BC
	LD	HL,CLBUF	;GET THE TEXT TO FSPEC
	LD	DE,(CMFCB)	;WHERE TO PUT THE RESULT
	CALL	XFSPEC		;MAKE IT A FILE SPEC
	PUSH	AF		;SAVE THE FLAGS
	PUSH	DE		;SAVE THE START
	LD	DE,CLBUF	;GET THE START
	OR	A		;RESET THE CARRY
	SBC	HL,DE		;COMPUTE THE OFFSET
	POP	DE		;GET THE START OF NEW BUFF
	ADD	HL,DE		;GET THE END
	LD	(HL),CR		;TERMINATE WITH A CR
	POP	AF		;RESTORE THE FLAGS
	POP	BC		;RESTORE BC
	POP	HL		;RESTORE HL
	JR	Z,CMIFI2	;GO IF FSPEC WAS OK
	CALL	XERROR		;PRINT THE MESSAGE
	RET			;ABORT COMPLETLY
CMIFI2	LD	(CMDPTR),HL
	LD	A,B		;GET THE LENGTH IN A
	JP	RSKP
CMINBF	PUSH   AF
	PUSH   DE
	PUSH   HL
	LD     A,(CMAFLG)	;IS THE ACTION CHAR FLAG SET?
	OR     A
	JP     NZ,CMINB9	;IF SO GET NO MORE CHARS.
	LD	HL,(CMCPTR)
	LD	DE,CMDBUF	;END OF BUFFER
	XOR	A
	SBC	HL,DE
	LD	B,L		;SIZE OF CMDBUF
	LD	HL,(CMCPTR)
	CALL	GETSTR		;LINE INPUT ROUTINE
	JP	C,PRSERR	;ACTION IF <BREAK> TYPED
	LD	A,B		;SAVE THE COUNT
	LD	(CMCCNT),A
	LD	C,B		;GET THE NUMBER OF CHARACTERS IN BUFFER
	LD	B,0
	LD	HL,CMDBUF
	ADD	HL,BC
	LD	(CMCPTR),HL
	LD	BC,CMDBUF
	OR	A
	SBC	HL,BC
	JP	Z,PRSERR	;IF NO CHARACTERS START OVER
CMINB6	LD     A,0FFH		;SET THE ACTION FLAG.
	LD     (CMAFLG),A
CMINB9	POP    HL
	POP    DE
	POP    AF
	RET    
CMGTCH	PUSH   HL
	PUSH   BC
CMGTC1	LD     A,(CMAFLG)
	OR     A		;IS IT SET.
	CALL   Z,CMINBF		;IS THE ACTION CHAR FLAG SET?
	LD     HL,(CMDPTR)	;GET A POINTER INTO THE BUFFER.
	LD     A,(HL)		;GET THE NEXT CHAR.
	INC    HL
	LD     (CMDPTR),HL
	CP     ' '		;IS IT A SPACE?
	JP     Z,CMGTC2
	CP     TAB		;OR A TAB?
	JP     NZ,CMGTC3
CMGTC2	LD     A,(CMSFLG)		;GET THE SPACE FLAG.
	OR     A			;WAS THE LAST CHAR A SPACE?
	JR     NZ,CMGTC1		;YES, GET ANOTHER CHAR.
	LD     A,0FFH		;SET THE SPACE FLAG.
	LD     (CMSFLG),A
	LD     A,' '
	POP    BC
	POP    HL
	JR     CMGTC5
CMGTC3	PUSH   AF
	XOR    A
	LD     (CMSFLG),A		;ZERO THE SPACE FLAG.
	POP    AF
	POP    BC
	POP    HL
	CP     ESC
	JR     Z,CMGTC5
	CP     '?'		;IS THE USER CURIOUS?
	JR     Z,CMGTC4
	CP     CR
	JR     Z,CMGTC4
	CP     LF
	JR     Z,CMGTC4
	CP     FF
	RET   NZ 		;NOT AN ACTION CHAR, JUST RETURN.
CMGTC4	PUSH   HL
	LD     HL,(CMDPTR)
	DEC    HL
	LD     (CMDPTR),HL
	POP    HL
CMGTC5	OR     80H		;MAKE THE CHAR NEGATIVE TO INDICATE IT IS
	RET    			;  A TERMINATOR.

