;	M4MIT/ASM
	ORG	3000H
; MODEL 4(P) KERMIT
; STARTED 10/1/84
; UPDATED 1/20/85
; MODIFIED BY GREGG WONDERLY
; BASED ON TRS-80 KERMIT
; SYMBOLIC DEFINITIONS FOR SOME ASCII CHARACTERS
;
BELL	EQU	07O		;ASCII BEL (CONTROL-G)
CTRLC	EQU	03O		;ASCII ETX (CONTROL-C)
TAB	EQU	11O		;ASCII TAB (CONTROL-I)
LF	EQU	12O		;ASCII LINE FEED (CTRL-J)
FF	EQU	14O		;ASCII FORM FEED (CTRL-L)
CR	EQU	15O		;ASCII CARRIAGE RETURN (CTRL-M)
XON	EQU	21O		;THE THE ASCII CHARACTER USED FOR XON
XOFF	EQU	23O		;THE THE ASCII CHARACTER USED FOR XOFF
ESC	EQU	33O		;ASCII ESCAPE
SUBT	EQU	32O		;ASCII SUB (CTRL-Z)
DEL	EQU	177O		;ASCII DELETE (RUBOUT)
DEFESC	EQU	31		;<CLEAR> KEY ON KEY BOARD
MAXPKT	EQU	'~'-' '+2O	; MAXIMUM SIZE OF A PACKET.
MAXTRY	EQU	05O		; DEFAULT NUMBER OF RETRIES ON A PACKET.
IMXTRY	EQU	20O		; DEFAULT NUMBER OF RETRIES SEND INITIATE.
DRPSIZ	EQU	5EH		; DEFAULT RECEIVE PACKET SIZE.
DSPSIZ	EQU	20H		; DEFAULT SEND PACKET SIZE.
DSTIME	EQU	08H		; DEFAULT SEND TIME OUT INTERVAL.
DRTIME	EQU	05H		; DEFAULT RECEIVE TIME OUT INTERVAL.
DSPAD	EQU	00H		; DEFAULT SEND PADDING.
DRPAD	EQU	00H		; DEFAULT RECEIVE PADDING.
DSPADC	EQU	00H		; DEFAULT SEND PADDING CHAR.
DRPADC	EQU	00H		; DEFAULT RECEIVE PADDING CHAR.
DSEOL	EQU	CR		; DEFAULT SEND EOL CHAR.
DREOL	EQU	CR		; DEFAULT RECEIVE EOL CHAR.
DSQUOT	EQU	'#'		; DEFAULT SEND QUOTE CHAR.
DRQUOT	EQU	'#'		; DEFAULT RECEIVE QUOTE CHAR.
DSCHKT	EQU	'1'		; DEFAULT CHECKSUM TYPE
SOH	EQU	01H		; START OF HEADER CHAR.
BUFSIZ	EQU	0
DIASW	EQU	01H		; DEFAULT IS DIAGNOSTICS ON.
CMKEY	EQU	01H		; PARSE A KEYWORD.
CMIFI	EQU	02H		; PARSE AN INPUT FILE SPEC (CAN BE WILD).
CMOFI	EQU	03H		; PARSE AN OUTPUT FILE SPEC.
CMCFM	EQU	04H		; PARSE A CONFIRM.
CMTXT	EQU	05H		; PARSE TEXT.
CMNUM	EQU	06H		; PARSE ASCII DECIMAL STRING
CMIFIN	EQU	10H		; PARSE AN INPUT FILE SPEC (BUT NO
;	ENTRY POINT FOR EXECUTION
START	LD	(OLDSP),SP
	LD	SP,STACK
	LD	A,101		;@FLAGS SVC
	RST	28H		;GET THE STATUS FLAGS IN IY
	LD	(FLAGS),IY	;SAVE FLAGS FOR LATER
	LD	A,100		;@HIGH SVC
	LD	B,1		;WE WANT LOW$
	PUSH	AF		;USE THEM AGAIN SO SAVE
	PUSH	BC
	LD	HL,0		;SELECT GET
	RST	28H		;GET LOW$ IN HL
	LD	(OLDLOW),HL	;SAVE FOR EXIT LATER
	POP	BC		;RESTORE THEM BACK
	POP	AF
	LD	HL,TOPMEM	;GET THE LOWEST ADDRESS USED
	RST	28H		;SET LOW$ TO THAT
	JP	NZ,XEXIT	;QUIT IF MEMORY ERROR
	LD	E,'C'		;GET THE *CL DEVICE
	LD	D,'L'
	LD	A,82		;@GTDCB SVC
	RST	28H		;GET IT OR TRY
	LD	(CLDCB),HL	;SAVE WHAT EVER WE GOT
	JR	NZ,NOCL		;JUMP ON AN ERROR FROM @GTDCB
	CALL	SETINT		;SET UP SOUND AND RECEIVER
	XOR	A		;ZERO A
	LD	(FCB),A		;SET FILE CLOSED FLAG
	CALL	CMBLNK		;CLEAR THE SCREEN
	LD	DE,INTRO	;PRINT INTRO MESSAGE
	CALL	PRTSTR
	CALL	CHKTAK		;CHECK AUTO TAKE FILE
	CALL	KERMIT		;GOTO KERMIT
	JP	EXIT1		;EXIT PROGRAM ON RETURN
NOCL	LD	DE,CFCL		;ERROR MESSAGE
	CALL	PRTSTR
	JP	EXIT2		;RETURN TO DOS
;CLEAR THE SCREEN, SAVING DE
CMBLNK	PUSH	DE
	LD	DE,CLRTOP
	CALL	PRTSTR
	POP	DE
QUIT	RET
CONOUT	PUSH	DE		;SAVE THE REGS
	PUSH	BC
	PUSH	AF
	CP	BELL		;IS IT A BELL
	JR	Z,BEEPON	;GO SET UP THE COUNTER IF SO
	LD	C,A		;C HAS DATA IN @DSP SVC
	LD	A,2		;@DSP SVC
	RST	28H		;DO IT
CON010	POP	AF		;RESTORE THE REGS
	POP	BC
	POP	DE
	RET			;RETURN TO THE CALLER
BEEPON	LD	A,(BELFLG)	;IS THAT OPTION ON?
	OR	A
	JR	Z,CON010	;NO BELL IF IT ISN'T
	LD	A,14		;COUNTER VALUE FOR INTERRUPTS
	LD	(BEPLEN),A
	JR	CON010		;GOTO POP AND RETURN
;	DISPLAY A STRING POINTED TO BY DE, ENDING WITH A '$'
PRTSTR	LD	A,(DE)		;GET A CHARACTER
	CP	'$'		;IS IT THE END?
	RET	Z		;RETURN TO CALLER IF SO
	OR	A		;THROW AWAY THE NULL CHARACTER
	CALL	NZ,CONOUT	;DISPLAY ANYTHING NON-NULL
	INC	DE		;POINT TO THE NEXT ONE
	JR	PRTSTR		;LOOP ON
;GET KEYBOARD INPUT
CONIN	PUSH	DE		;SAVE DE
	CALL	XKBD		;LOOK AT THE KEYBOARD WITHOUT WAITING
	POP	DE		;RESTORE DE
	RET			;RETURN TO THE CALLER
;	KERMIT COMMAND PARSER!
;	THIS IS WHERE EACH COMMAND ORIGINATES.
KERMIT	LD	DE,FCB		;WE ALWAYS CLOSE THE OPEN FILE
	LD	A,(DE)		;GET THE FLAGS BYTE FROM THE FCB
	BIT	7,A		;WAS FILE OPEN?
	CALL	NZ,XCLOSE	;CLOSE IT IF IT WAS
	LD	DE,KERM		;WHAT PROMPT TO PRINT
	CALL	PROMPT		;DISPLAY IT, AND DO SOME INITIALIZATION
	LD	DE,COMTAB	;GET THE COMMAND TABLE
	LD	A,CMKEY		;PARSE A KEYWORD FROM COMTAB
	CALL	COMND		;GET THE USERS COMMAND
	JP	KERMT2		;ABORT ON AN ERROR
	LD	HL,KERMTB	;GET THE JUMP TABLE
	LD	C,A		;GET THE OFFSET
	LD	B,0		;MAKE IT A 16 BIT VALUE
	ADD	HL,BC		;CALCULATE THE ADDRESS
	JP	(HL)		;GO TO THE JUMP
;	JUMP TABLE FOR PRIMARY COMMANDS
KERMTB	JP	TELNET		;CONNECT
	JP	EXIT		;EXIT
	JP	HELP		;HELP
	JP	LOG		;LOG
	JP	READ		;RECEIVE
	JP	SEND		;SEND
	JP	SETCOM		;SET
	JP	SHOW		;SHOW
	JP	STATUS		;STATUS
	JP	FINISH		;FINISH
	JP	LOGOUT		;LOGOUT
	JP	BYE		;BYE
	JP	DIR		;DIRECTORY
	JP	ERA		;KILL
	JP	LOCCOM		;LOCAL
	JP	SETCL		;SETCOM
	JP	TAKE		;TAKE
	JP	SOUREC		;INPUT
	JP	SOUSND		;OUTPUT
	JP	SOUPSE		;PAUSE
	JP	SOUMUL		;PULSE
	JP	CLEARC		;CLEAR
	JP	CLSFLS		;CLOSE
	JP	REMOTE		;REMOTE
;	CLOSE COMMAND.  AS MORE LOG FILES ARE ADDED, THIS IS WHERE THE
;	USER CAN EXPLICITLY CLOSE THEM
CLSFLS	LD	A,CMKEY		;PARSE A KEYWORD
	LD	DE,CLSTAB	;GET THE PARSE TABLE
	CALL	COMND		;GET A KEYWORD
	JP	KERMT2		;ABORT ON AN ERROR
	LD	(TEMP1),A	;SAVE THE VALUE
	LD	A,CMCFM		;GET A CONFIRM
	CALL	COMND
	JP	KERMT3		;SAY NO CONFIRMED
	LD	A,(TEMP1)	;RESTORE WHAT WE GOT
	OR	A		;IS IT ZERO (ONLY OPTION RIGHT NOW)
	JR	NZ,CLSF10	;SKIP IF NOT
	LD	A,(LOGFLG)	;CLOSE THE SESSION LOG IF IT IS OPEN
	OR	A		;IS IT OPEN?
	JR	Z,CLSF07	;GO IF IT IS NOT
	XOR	A		;RESET THE LOG FLAG
	LD	(LOGFLG),A	;DO IT
	LD	DE,LFCB		;GET THE FCB ADDRESS
	CALL	XCLOSE		;CLOSE THE FILE IF POSSIBLE
	CALL	NZ,XERROR	;GET AN ERROR MESSAGE IF NEEDED
	JP	KERMIT		;GO GET A NEW COMMAND
CLSF07	LD	DE,NOLOGF	;SAY LOG FILE NOT OPEN
	CALL	PRTSTR
	JP	KERMIT		;GET A NEW COMMAND
CLSF10	JP	KERMT2		;SAY UNRECOGNIZED COMMAND (NEVER HAPPENS)
;	CLEAR SOMETHING.  I.E.  SCREEN OR INPUT-PORT
CLEARC	LD	A,CMKEY		;GET A KEYWORD
	LD	DE,CLRTAB	;FROM THIS TABLE
	CALL	COMND
	JP	KERMT2		;SAY UNRECOGNIZED COMMAND ON AN ERROR
	OR	A		;IS IT ZERO?
	JP	NZ,CLR010	;SKIP IF NOT
	LD	A,CMCFM		;GET A CONFIRM
	CALL	COMND
	JP	KERMT3
	CALL	CLRPRT		;DO "CLEAR INPUT-PORT"
	JP	KERMIT		;GET A NEW COMMAND
CLR010	CP	3		;IS IT CLEAR SCREEN?
	JP	NZ,KERMT2	;SAY UNRECOGNIZED COMMAND IT NOT
	LD	A,CMCFM		;GET A CONFIRM
	CALL	COMND
	JP	KERMT3
	CALL	CMBLNK		;CLEAR THE SCREEN
	JP	KERMIT		;GET A NEW COMMAND
;	EXECUTE THE TAKE COMMAND
TAKE	LD	DE,TFCB		; WHERE TO PUT THE FILENAME
	LD	A,CMIFI		; GET A FILE NAME
	CALL	COMND		; GET USER INPUT
	JP	KERMT3		;ABORT ON AN ERROR
	LD	IY,(FLAGS)	;GET THE SYSTEM FLAGS
	SET	0,(IY+18)	;SET UP FOR NO FILE OPEN BIT
	LD	HL,TBUF		;THIS IS THE DATA BUFFER
	LD	DE,TFCB		;GET THE FILE FCB
	LD	B,0		;256 BYTE LRL
	CALL	XOPEN		;TRY TO OPEN THE FILE
	JR	NZ,TERROR	;GO REPORT AN ERROR
	LD	A,1
	LD	(TAKFLG),A	;SET THE FLAG
	JP	KERMIT
TERROR	CALL	XERROR		;PRINT THE MESSAGE
	XOR	A		;RESET THE TAKE FLAG
	LD	(TAKFLG),A
	JP	KERMIT		;GET A NEW COMMAND
;	SETCOM COMMAND
SETCL	LD	A,CMTXT		;GET ARBITRARY TEXT
	LD	DE,CLBUF	;BUFFER TO PUT DATA INTO
	CALL	COMND		;GET THE INPUT
	JP	KERMT3		;ABORT ON ERROR
	OR	A
	CALL	Z,NEWLIN	;NEED A NEW LINE TO PRINT ON
	LD	A,CR		;GET A TERMINATOR
	LD	(DE),A		;TERMINATE THE STRING
	LD	HL,CLBUF-7	;GET THE "SETCOM " PREFIX
	LD	A,25		;@CMNDR SVC TO DO THE COMMAND
	RST	28H		;DO IT
	JP	KERMIT		;GET A NEW COMMAND, IGNORE ANY ERROR CODE
;	LOCAL COMMAND
LOCCOM	LD	HL,(CMDPTR)	;GET THE ADDRESS OF THE START
SYST1	LD	A,(HL)		;GET A CHARACTER
	INC	HL		;POINT TO THE NEXT
	CP	' '		;LOOK FOR LEADING WHITE SPACE
	JR	Z,SYST1		;LOOP IF JUST BLANKS
	CP	CR		;LOOK FOR CURIOUS USER
	JR	Z,SYST2		;GO DO A LIB COMMAND
	CP	'?'		;LOOK FOR MORE CURIOSITY
	JR	NZ,SYST4	;GO IF NOT USER CURIOUS
SYST2	PUSH	HL		;SAVE THE ADDRESS TO PASS
	POP	IY		;GET A THE ADDRESS IN AN INDEX
	LD	(IY-1),'L'	;HL GO INCREMENTED UP THERE
	LD	(IY),'I'	;SPELLING OUT LIB
	LD	(IY+1),'B'
	LD	(IY+2),CR	;ADD THE TERMINATOR
SYST4	DEC	HL		;POINT TO THE ACTUAL ADDRESS
	CALL	NEWLIN		;NEED A NEW LINE
	LD	A,25		;@CMNDR SVC
	LD	IY,(FLAGS)	;SET ONLY LIBRARY COMMANDS
	SET	4,(IY+2)
	RST	28H		;TRY THE CONTENTS OF THE BUFFER
SYST5	JP	KERMIT		;IGNORE ANY ERRORS
;	AMBIGUOUS COMMAND MESSAGE
KERMT2	LD	DE,ERMES1	;ISSUE AMBIGUOUS COMMAND MESSAGE
	CALL	PRTSTR
	JP	KERMIT
;	NOT CONFIRMED MESSAGE
KERMT3	LD	DE,ERMES3	;ISSUE NOT CONFIRMED MESSAGE
	CALL	PRTSTR
	JP	KERMIT
;	OUTPUT A CHARCTER IN E TO THE COMMUNICATIONS PORT
OUTCHR	PUSH	DE		;SAVE CURRENT DE AND BC
	PUSH	BC
	LD	C,E
OUTCH0	LD	A,(XOFREC)	;CHECK TO SEE IF WE CAN TRANSMIT YET!
	OR	A
	JR	NZ,OUTCH0	;LOOP IF WE CAN'T
	LD	A,C
OUTCH1	LD	DE,(CLDCB)	;GET THE DCB OF THE DEVICE TO PUT TO
	CALL	XPUT		;SEND THE CHARACTER
	JR	NZ,OUTCH1	;LOOP UNTIL IT GETS SENT
	POP	BC		;RESTORE THE REGS
	POP	DE
	RET
;	GET A CHARACTER FROM THE PORT, OR THE KEYBOARD
;	MAINLY USED BY RPACK TO CHECK FOR ^Z, ^X, OR ^C.
INCHR	CALL	INPORT		;GET THE NEXT BUFFERED CHARACTER
	JP	Z,RSKP		;GO IF WE GOT ONE
	CALL	CONIN		;CHECK THE KEYBOARD
	OR	A		;DID WE FIND A KEY PRESSED?
	JR	Z,INCHR		;LOOP IF NOT
	CP	CR		;WAS IT ENTER?
	RET	Z		;RETURN IF IT WAS
INCHR4	CP	1AH		;CONTROL-Z?
	JR	Z,INCHR5
	CP	18H		;CONTROL-X?
	JR	NZ,INCHR
INCHR5	ADD	A,20H		;MAKE IT PRINTABLE
	LD	(CZSEEN),A
	RET
;	EXIT COMMAND
EXIT	LD	A,CMCFM		;MAKE SURE THEY ARE READY TO QUIT
	CALL	COMND
	JP	KERMT3
EXIT1	LD	DE,FCB		;GET THE FILE FCB AND CLOSE IF NEEDED
	LD	A,(FCB)
	BIT	7,A
	CALL	NZ,XCLOSE	;JUST IN CASE
	LD	A,(LOGFLG)	;CHECK THE LOGFLAG
	OR	A		;SET THE FLAGS
	LD	DE,LFCB		;GET THE FILE FCB
	CALL	NZ,XCLOSE	;CLOSE IT IF NECESSARY
	LD	C,4		;INTERRUPTS OPTION OF @CTL SVC
	LD	A,5		;@CTL
	LD	IY,0		;RESET OUR RECEIVER
	LD	DE,(CLDCB)	;GET THE RIGHT DEVICE
	RST	28H		;RESET IT
	CALL	CMBLNK		;CLEAR THE SCREEN
EXIT2	LD	HL,(OLDLOW)	;GET THE OLD HIGH MEMORY
	LD	A,100		;@HIGH SVC
	LD	B,1		;SET TO DEAL WITH LOW$
	RST	28H		;SET IT BACK THE WAY IT WAS
	LD	A,30		;REMOVE THE BELL TASK FROM THE TABLE
	LD	C,11		;TASK # 11
	RST	28H		;CALL @RMTSK
	LD	HL,(FINDCB)	;REMOVE THE *FI, AND *FO DEVICES
	CALL	ZERO8		;SET ALL 8 BYTES TO ZERO
	LD	HL,(FOTDCB)	;DO THE SAME FOR *FO
	CALL	ZERO8
	LD	SP,(OLDSP)	;RESTORE THE OLD STACK POINTER
	JP	XEXIT		;TAKE SYSTEM EXIT
ZERO8	LD	D,H		;PUT A COPY OF HL INTO DE
	LD	E,L
	LD	BC,7		;8 BYTES TO MOVE
	LD	(HL),0		;SET THE FIRST TO ZERO
	INC	DE		;POINT ONE AHEAD FOR THE COPY
	LDIR			;DO IT TO ALL OF THEM
	RET			;RETURN TO THE CALLER
;	HELP COMMAND
HELP	LD	A,CMCFM		;MAKE SURE THEY WANT HELP
	CALL	COMND
	JP	KERMT3		;NOT CONFIRMED IF ERROR
	LD	DE,TOPHLP	;PRINT THE COMMAND HELP STRING
	CALL	PRTSTR
	CALL	NEWLIN		;GET A NEW LINE
	CALL	NEWLIN		;PLUS ANOTHER
	JP	KERMIT
*GET 	M4CMD/ASM		;COMMAND PARSER
*GET	M4MORE/ASM		;MOST OF THE NON PROTOCOL RELATED COMMANDS
*GET	M4GET/ASM		;RECEIVE PROTOCOL
*GET	M4SEND/ASM		;SEND PROTOCOL
*GET	M4XFER/ASM		;PROTOCOL COMMON CODE
*GET 	M4STR/ASM		;STRINGS
*GET	M4ADD/ASM		;MY MODIFICATIONS
*GET	M4RMT/ASM		;remote commands
*GET	M4LOG/ASM		;SOURCE COMMAND
TOPMEM	EQU	$+10
	END	START
