;	M4MORE/ASM
; THIS IS WHERE WE GO IF WE GET AN ERROR DURING A PROTOCOL COMMUNICATION.
; CALL ERROR PRINTS THE ERROR PACKET ON LINE 6 OR SO.
; CALL ERROR1 PRINT CRLF FOLLOWED BY THE ERROR PACKET.
; CALL ERROR2 JUST PRINTS THE ERROR PACKET.
; CALL ERROR3 POSITIONS CURSOR AND PRINTS ERROR MESSAGE SPECIFIED IN DE.
ERROR	CALL	ERROR9		; POSITION THE CURSOR.
	LD	A,'A'		; SET THE STATE TO ABORT.
	LD	(STATE),A
	JP	ERROR2
ERROR1	LD	DE,CRLF		; PRINT A CRLF.
	CALL	PRTSTR
ERROR2	LD	A,(ARGBLK+1)	; GET THE LENGTH OF THE DATA.
	LD	C,A
	LD	B,0		; PUT IT INTO BC
	LD	HL,DATA		; GET THE ADDRESS OF THE DATA.
	ADD	HL,BC		; GET TO THE END OF THE STRING.
	LD	A,'$'		; PUT A DOLLAR SIGN AT THE END.
	LD	(HL),A
	LD	DE,DATA		; PRINT ERROR MESSAGE
	CALL	PRTSTR
	RET	
ERROR3	PUSH	DE		; SAVE THE POINTER TO THE MESSAGE.
	CALL	ERROR9		; POSITION THE CURSOR.
	LD	DE,CLRLIN	; CLEAR THE LINE
	CALL	PRTSTR
	POP	DE		; GET THE POINTER BACK.
	CALL	PRTSTR		; PRINT ERROR MESSAGE
	RET	
ERROR9	LD	DE,SCRERR	; POSITION CURSOR
	CALL	PRTSTR
	RET	
ERRORD	OR	A		;display disk error
	RET	Z
	CALL	XERROR
	RET
FINMES	PUSH	DE		; SAVE MESSAGE.
	LD	DE,SCRST
	CALL	PRTSTR
	POP	DE		; PRINT THE TERMINATION MESSAGE
	CALL	PRTSTR
	LD	DE,SCREND	; POSITION CURSOR FOR PROMPT
	CALL	PRTSTR
	RET	
; THIS IS THE FINISH COMMAND.	IT TELLS THE REMOTE KERSRV TO EXIT.
FINISH	LD	A,CMCFM
	CALL	COMND		; GET A CONFIRM.
	JP	KERMT3
	CALL	CLRPRT		; CLEAR ANY STACKED NAKS
	XOR	A		;  DIDN'T GET A CONFIRM.
	LD	(NUMTRY),A	; INITITIALIZE COUNT.
	LD	A,'1'		; RESET BLOCK CHECK TYPE TO SINGLE CHARACTER
	LD	(CURCHK),A	;  .  .  .
FINSH1	LD	A,(NUMTRY)	; HOW MANY TIMES HAVE WE TRIED?
	CP	MAXTRY		; TOO MANY TIMES?
	JP	M,FINSH3	; NO, TRY IT.
FINSH2	LD	DE,ERMS18	; SAY WE COULDN'T DO IT.
	CALL	PRTSTR
	JP	LOG111		; GO HOME.
FINSH3	INC	A		; INCREMENT THE NUMBER OF TRIES.
	LD	(NUMTRY),A
	XOR	A
	LD	(ARGBLK),A	; MAKE IT PACKET NUMBER ZERO.
	LD	A,1
	LD	(ARGBLK+1),A	; ONE PIECE OF DATA.
	LD	HL,DATA
	LD	(HL),'F'	; FINISH RUNNING KERMIT.
	LD	A,'G'		; GENERIC COMMAND PACKET.
	CALL	SPACK
	JP	FINSH1
	CALL	RPACK	 	;GET AN ACKNOWLEDGEMENT.
	JP	FINSH1
	CP	'Y'		; ACK?
	JP	Z,KERMIT	; YES, WE ARE DONE.
	CP	'E'		; IS IT AN ERROR PACKET?
	JP	NZ,FINSH1	; TRY SENDING THE PACKET AGAIN.
	CALL	ERROR1		; PRINT THE ERROR MESSAGE.
	JP	KERMIT
; THIS IS THE LOGOUT COMMAND.	IT TELLS THE REMOTE KERSRV TO LOGOUT.
LOGOUT	LD	A,CMCFM
	CALL	COMND		; GET A CONFIRM.
	JP	KERMT3
	CALL	LOGO		; SEND THE LOGOUT PACKET.
	JP	LOG111		; GO GET ANOTHER COMMAND
	JP	KERMIT		;  WHETHER WE SUCCEED OR NOT.
LOGO	XOR	A
	LD	(NUMTRY),A	; INITITIALIZE COUNT.
	CALL	CLRPRT		; CLEAR ANY STACKED NAKS
	LD	A,'1'		; RESET BLOCK CHECK TYPE TO SINGLE CHARACTER
	LD	(CURCHK),A	;  .  .  .
LOGO1	LD	A,(NUMTRY)	; HOW MANY TIMES HAVE WE TRIED?
	CP	MAXTRY		; TOO MANY TIMES?
	JP	M,LOGO3		; NO, TRY IT.
LOGO2	LD	DE,ERMS19	; SAY WE COULDN'T DO IT.
	CALL	PRTSTR
	RET			; FINISHED.
LOGO3	INC	A		; INCREMENT THE NUMBER OF TRIES.
	LD	(NUMTRY),A
	XOR	A
	LD	(ARGBLK),A	; MAKE IT PACKET NUMBER ZERO.
	LD	A,1
	LD	(ARGBLK+1),A	; ONE PIECE OF DATA.
	LD	HL,DATA
	LD	(HL),'L'	; LOGOUT THE REMOTE HOST.
	LD	A,'G'		; GENERIC COMMAND PACKET.
	CALL	SPACK
	JP	LOGO2
	CALL	RPACK		; GET AN ACKNOWLEDGEMENT
	JP	LOGO1
	CP	'Y'		; ACK?
	JP	Z,RSKP		; YES, WE ARE DONE.
	CP	'E'		; IS IT AN ERROR PACKET?
	JP	NZ,LOGO1	; TRY SENDING THE PACKET AGAIN.
	CALL	ERROR1		; PRINT THE ERROR MESSAGE.
	RET			; ALL DONE.
; THIS IS THE BYE COMMAND.	IT TELLS THE REMOTE KERSRV TO LOGOUT AND EXITS.
BYE	LD	A,CMCFM
	CALL	COMND		; GET A CONFIRM.
	JP	KERMT3
	CALL	LOGO		; TELL THE MAIN FRAME TO LOGOUT.
	JP	LOG111		; IF IT FAILS, DON'T EXIT.
	JP	EXIT1		; EXIT KERMIT.
LOG111	CALL	NEWLIN		; GET A NEW LINE
	JP	KERMIT
; THIS IS THE LOG COMMAND.  IT LOGS A SESSION TO A FILE.
LOG	LD	A,(LOGFLG)	; CHECK IF WE ARE ALREADY LOGGING
	OR	A
	JR	Z,LOGOK
	LD	DE,LOGOPN	; PRINT MESSAGE THAT LOG FILE IS OPEN
	CALL	PRTSTR
	JP	KERMIT		; RETURN TO COMMAND PARSER
LOGOK	LD	A,CMIFI		; PARSE AN INPUT FILE SPEC.
	LD	DE,LFCB
	CALL	COMND
	JP	KERMT3
	LD	A,2H		;set the logging flag
	LD	(LOGFLG),A	;WITH WRITE ENABLED
	LD	HL,LBUFF
	LD	DE,LFCB
	LD	B,0
LOG1A	CALL	XINIT
	JP	Z,KERMIT	; QUIT IF IT DID WORK
	PUSH	AF		;SAVE THE ERROR AND THE FLAGS
	XOR	A		;RESET THE LOGGING FLAG
	LD	(LOGFLG),A	
	POP	AF		;RESTORE THE ERROR
	CALL	XERROR		;PRINT AN ERROR
	JP	KERMIT		;GET A NEW COMMAND
;this is the connect command
TELNET	LD	A,CMCFM
	CALL	COMND
	JP	KERMT3
	LD	DE,CLRTOP
	CALL	PRTSTR
TELE1	LD	DE,INFMS7
	CALL	PRTSTR
	CALL	ESCPR
	LD	DE,INFMS8
	CALL	PRTSTR
CHRLUP	XOR	A
	LD	(CHCNT),A
	CALL	PRTCHR
	CALL	CONCHR
	JP	KERMIT
	JP	CHRLUP
INPORT	PUSH	HL		;SAVE HL
	LD	HL,(NXTCHR)	;GET THE ADDRESS OF NEXT
	LD	A,(CURCHR)	;GET THE LSB OF THE CURRENT
	CP	L		;CHECK FOR NONE THERE
	JR	Z,INOUT		;NONE IF EQUAL
	LD	A,(FLOFLG)	;ARE WE DOING FLOW-CONTROL?
	OR	A		;SET THE FLAGS
	LD	A,(HL)		;GET THE CHARACTER IN CASE WE AREN'T
	JR	Z,INP11		;GO IF WE AREN'T DOING FLOW CONTROL
	DI			;INTERRUPT OFF FOR NOW
	LD	(SVCHAR),A	;SAVE THE CHARACTER FOR NOW
	INC	L
	LD	(NXTCHR),HL
	LD	A,(INCNT)	;DECREMENT THE COUNT
	DEC	A
	LD	(INCNT),A	;STORE IT BACK
	EI			;INTERRUPTS BACK ON
	PUSH	BC		;SAVE C
	LD	C,A		;GET A COPY OF THE COUNT
	LD	A,(XFFLG)	;CHECK IF XOFF SENT
	OR	A		;IS THE FLAG ON
	JR	Z,INP10		;GO IF NOT
	LD	A,100		;CHECK IF TIME FOR XON
	CP	C		;IS 100 >= COUNT
	JP	M,INP10		;GO IF STILL TOO MANY LEFT
	PUSH	DE		;SAVE E FOR XON
	LD	E,XON		;GET IT
	CALL	OUTCHR		;SEND AN XON
	XOR	A		;RESET THE FLAG
	LD	(XFFLG),A	; ZERO
	POP	DE		;RESTORE DE
INP10	POP	BC		;RESTORE OLD BC
	LD	A,(SVCHAR)	;GET THE NEXT CHARACTER
INP11	CP	A		;SET Z STATUS
INOUT1	POP	HL		;RESTORE HL
	RET
INOUT	INC	L		;NOW A & L ARE NOT EQUAL
	CP	L		;SET NZ STATUS
	PUSH	AF		;SAVE THE FLAGS
	XOR	A		;SAY NO CHARACTERS AVAILABLE
	LD	(INCNT),A
	POP	AF
	POP	HL		;RESTORE STACK
	RET
SVCHAR	DB	0
PRTCHR	CALL	INPORT
	RET	NZ
	CP	32
	JR	NC,T1
	LD	HL,TRTAB	;GET THE TRANSLATION TABLE
	LD	C,A		;PUT THE CHARACTER IN C
	LD	B,0		;MAKE BC AN OFFSET INTO TABLE
	ADD	HL,BC		;CALCULATE THE ADDRESS
	LD	A,(HL)		;GET THE NEW CHAR IN A
	OR	A		;IGNORE NULLS
	RET	Z
	CP	12		;IS IT A FORMFEED
	JP	Z,CMBLNK	;GO BLANK THE SCREEN
T1	LD	E,A		;SAVE THE CHARACTER
	LD	A,(VTFLG)	;CHECK FOR VT53 EMULATION
	OR	A		;SET THE FLAGS
	JR	Z,PRTCH1	;GO IF NOT VT52 MODE
	LD	A,(ESCFLG)	;CHECK IF ESCAPE FLAG SET
	OR	A		;SET THE FLAGS
	LD	A,E		;GET A COPY
	JP	NZ,VT52		;GO IF IT IS
	CP	ESC		;IS THIS ONE ESCAPE?
	JR	NZ,PRTCH1	;JUMP IF NOT
	LD	(ESCFLG),A	;SET THE FLAG WITH NON-ZERO
	JP	PRTCHR
PRTCH1	LD	A,E		;GET THE CHARACTER
	CALL	LOGONE		;CHECK FLAG ELSE WHERE
	LD	A,(PRTFLG)	;CHECK FOR PRINTER OUTPUT
	OR	A		;SET THE FLAGS
	CALL	NZ,PRTIT	;GO PRINT IT
	LD	A,E		;GET THE CHARACTER AND DISPLAY
	CALL	CONOUT		;PRINT IT ON THE SCREEN
	LD	A,(CHCNT)	;CHECK CHARACTER COUNT
	LD	B,A		;GET IT IN B
	DJNZ	CHK002		;SKIP RETURN IF NOT LIMIT
	RET			;RETURN AFTER LIMIT IS UP
CHK002	LD	A,B		;GET THE NEW COUNT
	LD	(CHCNT),A	;SAVE IT
	JP	PRTCHR		;LOOP ON
CONCHR	CALL	CONIN		;GET A KEYBOARD CHARACTER
	OR	A
	JP	Z,RSKP		;RETURN IF NONE FOUND
	PUSH	HL		;DO "SET KEY" TRANSLATIONS
	LD	HL,TRNCON
	PUSH	BC
	LD	C,A
	LD	B,0
	ADD	HL,BC
	LD	A,(HL)
	POP	BC
	POP	HL
	LD	E,A		;IS IT THE ESCAPE CHARACTER?
	LD	A,(ESCCHR)
	CP	E
	JP	Z,INTCHR
	LD	A,E
;	CALL	LOGONE
	LD	A,(VTFLG)
	OR	A
	JR	Z,NOVT52
	LD	A,E
	CP	136		;MAP CLEAR ARROWS TO VT52'S ARROW KEYS
	JP	M,NOVT52	;NOT CLEAR LEFT ARROW OR BIGGER
	CP	140		;CHECK CLEAR UP ARROW
	JP	P,NOVT52	;GREATER THE CLEAR UP ARROW
	LD	A,ESC		;GET AN ESCAPE FOR THE 2 CHAR SEQ
	PUSH	DE
	CALL	PRTOUT		;SEND IT OUT THE PORT
	POP	DE
	LD	A,E		;GET THE REAL CHARACTER
	LD	B,0		;GET READY TO LOOK IT UP
	SUB	136		;MAKE A AN OFFSET INTO THE TABLE
	LD	C,A		;BC IS NOW THE OFFSET
	LD	HL,VTTAB1	;GET THE LOOKUP TABLE
	ADD	HL,BC
	LD	A,(HL)		;GET THE ACTUAL CHARACTER
	JR	VTGO
NOVT52	LD	A,E
VTGO	PUSH	DE		;SAVE DE
	CALL	PRTOUT		;SEND IT TO THE PORT
NOESC	POP	DE
	LD	A,(ECOFLG)	;CHECK FOR LOCAL ECHO
	OR	A
	JP	Z,RSKP		;RETURN IF NO ECHO NEEDED
	LD	A,E
	AND	7FH		;NOW TRUNCATE TO 7 BITS
	CALL	CONOUT
	JP	RSKP		;RETURN TO THE CALLER SAY OK
INTCHR	CALL	CONIN		;GET A CHARACTER
	OR	A
	JR	Z,INTCHR
	LD	B,A
	AND	137O
	CP	'C'		;is it close?
	JP	NZ,INTCHR0	;no
	LD	DE,INFMS9
	CALL	PRTSTR
	RET
INTCHR0	CP	'S'		;status?
	JR	NZ,INCH01
	CALL	STAT01		;print out status
	JP	RSKP
INCH01	LD	A,B
	CP	'?'
	JR	NZ,INTCH1
	LD	DE,INTHLP
	CALL	PRTSTR
	JP	INTCHR
INTCH1	CALL	CAPTAL
	CP	'B'
	JR	NZ,INTCH2
	LD	C,1		;OPTION 1 OF @CTL
	LD	A,5		;@CTL SVC
	RST	28H		;CALL IT
	LD	BC,5000		;WAIT FOR A SEC
	LD	A,16		;@PAUSE SVC
	RST	28H		;WAITING
	LD	E,0		;SEND A NULL TO RESET BREAK
	CALL	OUTCHR		;OUT THE PORT WITH IT
	JP	RSKP
INTCH2	LD	A,B
	CP	'0'
	JR	NZ,INTCH3
	LD	E,0
	CALL	OUTCHR
	JP	RSKP
INTCH3	LD	E,B
	LD	A,(ESCCHR)
	CP	E
	JR	Z,INTCHZ
	LD	A,B
	CALL	CAPTAL
	CP	'Q'		; QUIT LOGGING?
	JR	NZ,INTCH4
	LD	A,(LOGFLG)
	CP	2		; SEE IF WE CAN TURN LOGGING OFF
	JR	NZ,INTC3A
	DEC	A
	LD	(LOGFLG),A
	JP	RSKP
INTC3A	LD	A,BELL
	CALL	CONOUT		; BEEP AT THEM
	JP	RSKP
INTCH4	CP	'R'
	JR	NZ,INTCH5
	LD	A,(LOGFLG)
	CP	1
	JR	NZ,INTC3A
	INC	A
	LD	(LOGFLG),A
	JP	RSKP
INTCH5	LD	A,E
	CALL	PRTOUT
	JP	RSKP
INTCHZ	CALL	OUTCHR		;SEND IT OUT THE PORT
	LD	A,BELL
	CALL	CONOUT
	JP	RSKP
PRTIT	IN	A,(0F8H)	;get printer status
	AND 	0F0H
	CP	30H
	RET	NZ		;skip this one
	LD	A,E
	PUSH	DE
	CALL	XPRT		;dos printer routine
	POP	DE
	RET
PRTOUT	OR	A
	RET	Z
	LD	E,A
	CALL	OUTCHR
	RET
; THIS IS THE SET COMMAND.
SETCOM	LD	DE,SETTAB	; PARSE A KEYWORD FROM THE SET TABLE.
	LD	A,SHLEN/3	;CHANGE NUMBER OF ENTRIES BACK
	LD	(SETTAB),A	;DO IT
	LD	A,MXSLEN	; GET MAX LENGTH ENTRY FOR SET TABLE
	LD	(SETTAB+1),A
	LD	HL,SETHLP	; GET ADDRESS OF HELP (NOT USED IN COMND)
	LD	(HL),CR		;PATCH ANY CHANGES MADE BY SHOW
	LD	A,CMKEY
	CALL	COMND
	JP	KERMT2
	LD	HL,SETJTB	; GET THE ADDRESS OF THE JUMP TABLE.
	LD	C,A
	LD	B,0
	ADD	HL,BC
	JP	(HL)  
;	SET COMMAND JUMP TABLE
SETJTB	JP	ESCAPE		; SET ESC
	JP	LOCAL		; SET LOCAL
	JP	FILWAR		; SET WARNING
	JP	SETCPM		; SET FILE-MODE
	JP	BLKSET		; SET BLOCK-CHECK-TYPE
	JP	VT52EM		; SET VT52
	JP	PRINTR		; set printer
	JP	SETBUG		; SET DEBUG
	JP	SETDSK		; SET DEFAULT DISK
	JP	SETBEL		; SET BELL ON OR OFF
	JP	BAUD		; SET BAUD RATE
	JP	IBMSET		; SET IBM MODE
	JP	PARSET		; SET PARITY
	JP	SETSND		; SET SEND PARAMETERS
	JP	SETREC		; SET RECEIVE PARAMTERS
	JP	SETBCK
	JP	SETKEY		; SET A KEY FOR TRANSLATION
	JP	SETFLO		; SET FLOW CONTROL
	JP	SETINP		; SET INPUT PARAMETERS
	JP	SETOTP		; SET OUTPUT PARAMETERS
	JP	SETTAK
SHLEN	EQU	$-SETJTB	; OFFSET FOR SHOW ALL
SETTAK	CALL	ONOFF
	LD	(TAKLOG),A
	JP	KERMIT
SETINP	LD	A,CMKEY		; GET A KEYWORD
	LD	DE,INPTAB	; WHERE ARE THE KEYWORDS AT?
	CALL	COMND
	JP	KERMT2		; QUIT ON AN ERROR
	CP	0		; CHECK FOR FIRST
	JR	NZ,STINP1
	CALL	ONOFF		; GET ON OR OFF
	LD	(CSEFLG),A	; GET CASE IGNORE
	JP	KERMIT
STINP1	CP	3
	JP	NZ,KERMT3
	CALL	ONOFF
	LD	(INDSP),A
	JP	KERMIT
SETOTP	LD	A,CMKEY
	LD	DE,OUTTAB
	CALL	COMND
	JP	KERMT2
	CP	0
	JR	NZ,STOTP1
	CALL	ONOFF
	LD	(ECHFLG),A
	JP	KERMIT
STOTP1	CP	3
	JP	NZ,KERMT3
	CALL	ONOFF
	LD	(OTDSP),A
	JP	KERMIT
SETFLO	LD	DE,FLOTAB
	LD	A,CMKEY
	CALL	COMND
	JP	KERMT2
	LD	(TEMP1),A
	LD	A,CMCFM
	CALL	COMND
	JP	KERMT3
	LD	A,(TEMP1)
	LD	(FLOFLG),A	;STORE THE NEW STATUS
	JP	KERMIT
SAVKY1	DW	0		; STORAGE FOR FROM KEY VALUE OFFSET
SAVKY2	DW	0		; STORAGE FOR TO VALUE
SETKEY	LD	A,CMNUM		; PARSE AN INPUT NUMBER
	CALL	COMND
	JP	KERMT2
	OR	A		; CHECK FOR NO NUMBER
	JP	Z,KERMT2	; SAY AMBIGOUS
	LD	(SAVKY1),DE	; SAVE THE FROM VALUE
	LD	A,D		; CHECK FOR OVERFLOW
	OR	A
	JR	NZ,SETK05	; GO IF THERE WAS
	LD	A,CMNUM		; GET THE TO VALUE
	CALL	COMND
	JP	KERMT3
	OR	A		; CHECK FOR NO NUMBER
	JP	Z,KERMT2	; SAY AMBIGUOUS
	LD	(SAVKY2),DE	; SAVE THE TO VALUE
	LD	A,D
	OR	A
	JR	NZ,SETK05
	LD	A,CMCFM		; GET A CONFIRM
	CALL	COMND
	JP	KERMT3		; SAY NOT-CONFIRMED
	LD	DE,(SAVKY2)
	JR	SETK10
SETK05	LD	DE,OUTRNG	; PRINT THE OUT OF RANGE MESSAGE
	CALL	PRTSTR
	JP	KERMIT
SETK10	LD	BC,(SAVKY1)	; GET THE FROM VALUE
	LD	HL,TRNCON	; GET THE START OF THE TABLE
	ADD	HL,BC		; POINT TO THE KEY
	LD	(HL),E		; SET THE NEW VALUE
	JP	KERMIT
KYSTAT	LD	A,CMNUM		; GET WHICH KEY
	CALL	COMND		; GET IT
	JP	KERMT3		; SAY NOT CONFIRMED
	OR	A		; CHECK FOR NO NUMBER
	JP	Z,KERMT2	; SAY AMBIGUOUS
	LD	A,D		; CHECK FOR OVERFLOW
	OR	A
	JP	NZ,SETK05
	LD	HL,TRNCON	; GET THE TABLE
	ADD	HL,DE		; CALCULATE THE ADDRESS
	LD	A,(HL)		; GET THE CHARACTER THERE
	PUSH	AF		; SAVE IT
	LD	DE,KEYST	; PRINT THE DESCRIPTION STRING
	CALL	PRTSTR
	POP	AF		; RESTORE THE VALUE
	CALL	ANOUT		; PRINT THE VALUE THERE
	RET			; RETURN 
SETBCK	LD	A,CMKEY		; GET A KEYWORD
	LD	DE,BCKTAB	; GET THE KEYWORDS
	CALL	COMND		; GET THE KEYWORD
	JP	KERMT2		; SAY AMBIGUOUS
	LD	(TEMP1),A	; SAVE THE BACKSPACE THAT WE GOT
	LD	A,CMCFM		; GET A CONFIRM
	CALL	COMND
	JP	KERMT3		; SAY NOT CONFIRMED
	LD	A,(TEMP1)	; GET THE VALUE FROM THE PARSE
	LD	(BCKCHR),A	; STORE THE NEW BACKSPACE CHARACTER
	JP	KERMIT		; GET A NEW COMND
SETBEL	CALL	ONOFF		; GET ON OR OFF
	LD	(BELFLG),A	; STORE THE FLAG VALUE
	JP	KERMIT		; GET A NEW COMMAND
BLKSET	LD	DE,BLKTAB	; GET THE ADDRESS OF THE BLOCK-CHECK TABLE
	LD	A,CMKEY		; PARSE A KEYWORD
	CALL	COMND		; GO GET IT
	JP	KERMT2		; COULDN'T, COMPLAIN
	LD	(TEMP1),A	; SAVE THE PARSED ITEM
	LD	A,CMCFM		; WANT TO END THE COMMAND
	CALL	COMND		; GO DO IT
	JP	KERMT3		; GIVE UP
	LD	A,(TEMP1)	; GET THE VALUE BACK
	LD	(CHKTYP),A	; SAVE DESIRED CHECKSUM TYPE
	JP	KERMIT		; GO GET ANOTHER COMMAND
;
;
SETSND	XOR	A		;SET SEND/RECEIVE TO SEND
	JR	SETSOR
;
;
SETREC	LD	A,1		;SET SEND/RECEIVE TO RECEIVE
SETSOR	LD	(SORFLG),A	; STORE THE FLAG
	LD	DE,STSNTB	; GET THE PARSE TABLE
	LD	A,CMKEY
	CALL	COMND		; PARSE SOMETHING
	JP	KERMT2		; ABORT
	LD	HL,STSJTB	; GET THE JUMP TABLE
	LD	C,A
	LD	B,0
	ADD	HL,BC
	JP	(HL)
STSJTB	JP	STPDCH		; SET PAD CHARACTER
	JP	STPAD		; SET PADDING ON/OFF
	JP	SSOFP		; SET START OF PACKET
	JP	STIMEO		; SET TIME OUT
	JP	SSEOL		; SET END OF LINE
	JP	SSQUOT		; SET QUOTE CHARACTER
STPAD	LD	A,CMNUM		;GET A LENGTH COUNT
	CALL	COMND		; PARSE A VALUE
	JP	KERMT3		; NOT CONFIRMED ON AN ERROR
	OR	A		; CHECK FOR NO NUMBER
	JP	Z,KERMT2	; SAY AMBIGUOUS
	LD	A,D		; CHECK FOR OVERFLOW
	OR	A		; SET THE FLAGS
	JR	Z,STPD10	; GOT IF NONE
	LD	DE,OUTRNG
	CALL	PRTSTR
	JP	KERMIT
STPD10	LD	A,E
	LD	(SPAD),A		; SET THE STATUS
	JP	KERMIT		; GET A NEW COMMAND
STPDCH	LD	HL,SPADCH	; GET THE ADDRESS TO STORE AT
SOR010	LD	(SORLOC),HL	; SAVE IT FOR LATER
	LD	A,CMNUM		;GET A DECIMAL NUMBER
	CALL	COMND
	JP	KERMT3
	OR	A		; CHECK FOR NO NUMBER
	JP	Z,KERMT2	; SAY AMBIGUOUS
	LD	A,D		;CHECK FOR TOO BIG
	OR	A		;SET THE FLAGS
	JR	Z,PDCH2		;GO IF OK
	LD	DE,OUTRNG	;VALUE OUT OF RANGE ERROR
	CALL	PRTSTR		;PRINT IT
	JP	KERMIT
PDCH2	LD	HL,(SORLOC)	;GET WHERE TO PUT IT
	LD	A,(SORFLG)	;GET THE MODE, SEND/RECEIVE
	OR	A		;CHECK FOR SET OR RESET FLAG
	CALL	Z,SSVAL		;IF ZERO THEN SET RECEIVE VALUE
	CALL	NZ,SRVAL		;ELSE SET THE SEND VALUE
	JP	KERMIT		;GET A NEW COMMAND
;	SET SEND/RECEIVE START-OF-PACKET character
SSOFP	LD	HL,SSOHCH
	JP	SOR010
;	Set SEND/RECEIVE	TIME-OUT value
STIMEO	LD	HL,STIME
	JP	SOR010
;	Set SEND/RECEIVE END-OF-LINE character
SSEOL	LD	HL,SEOL
	JP	SOR010
;	Set SEND/RECEIVE quoting character
SSQUOT	LD	HL,SQUOTE
	JP	SOR010
;	Convert ASCII Decimal string to binary in BC, HL is the source buffer
DECHEX	LD	A,96
	RST	28H
	RET
;	Store E at HL
SRVAL	LD	(HL),E
	RET
;	Store E at HL+1
SSVAL	INC	HL
	LD	(HL),E
	RET
;	PRINT OUT THE ACCUMLATOR IN ASCII ON THE SCREEN AT CURRENT POS
ANOUT	PUSH	HL
	LD	L,A
	LD	H,0
	CALL	NOUT
	POP	HL
	RET
ESCAPE	LD	A,CMCFM		; NOT (BRAIN OR OSBRN1 OR KPII)
	CALL	COMND		; GET A CONFIRM.
	JP	KERMT3		;  DIDN'T GET A CONFIRM.
	LD	DE,ESCMES	; GET THE ADDRESS OF THE ESCAPE MESSAGE.
	CALL	PRTSTR
	CALL	XKEY
	LD	(ESCCHR),A	; STORE THE NEW ESCAPE CHARACTER.
	CALL	ESCPR		; Print the Verbpse description of it
	JP	KERMIT
;	THIS IS THE LOCAL ECHO SET SUBCOMMAND.
LOCAL	CALL	ONOFF
	LD	(ECOFLG),A	; SET THE LOCAL ECHO FLAG.
	JP	KERMIT
;	THIS IS THE VT52 EMULATION SET SUBCOMMAND.
VT52EM	CALL	ONOFF
	LD	(VTFLG),A	; SET THE VT52 EMULATION FLAG.
	JP	KERMIT
; THIS IS THE FILE-WARNING SET SUBCOMMAND
FILWAR	CALL	ONOFF
	LD	(FLWFLG),A	; SET THE FILE-WARNING FLAG.
	JP	KERMIT
;
SETCPM	LD	DE,TYPTAB
	CALL	ONOFFA
	LD	(CPMFLG),A	;SET THE CPM FLAG
	JP	KERMIT
;	Set Printer command
PRINTR	CALL	ONOFF
	LD	(PRTFLG),A
	JP	KERMIT
;SET DEBUG
SETBUG	CALL	ONOFF
	LD	(DBFLG),A
	JP	KERMIT
;
ONOFF	LD	DE,ONTAB
ONOFFA	LD	A,CMKEY
	CALL	COMND
	JP	ONOFF2
	LD	(TEMP1),A
	LD	A,CMCFM
	CALL	COMND
	JP	ONOFF3
	LD	A,(TEMP1)
	RET
ONOFF2	POP	AF
	JP	KERMT2
ONOFF3	POP	AF
	JP	KERMT3
; THIS IS THE SHOW COMMAND.
SHOW	LD	A,SHLEN	; GET THE OFFSET TO OVERWRITE WITH
	LD	(SETTAB),A	;FIX SET TABLE FOR SHOW
	LD	(SETTAB+1),A
	LD	A,'s'		;LAST CHARACTER IN ALL DESCRIPTION
	LD	(SETHLP),A	;FIX THIS TABLE TOO
	LD	A,CMKEY
	LD	DE,SHOTAB
	LD	HL,SHOHLP
	CALL	COMND
	JP	KERMT2
	CP	KYLEN		;IS THIS THE SHOW KEY COMMAND?
	JR	Z,NOCFM		;SKIP THE CONFIRM
	LD	(TEMP1),A	;SAVE THE JUMP OFFSET
	LD	A,CMCFM
	CALL	COMND		;GET A CONFIRM
	JP	KERMT3		;SAY NOT CONFIRMED ON AN ERROR
	LD	A,(TEMP1)
NOCFM	LD	HL,SHOJTB
	LD	C,A
	LD	B,0
	ADD	HL,BC		;HL IS WHERE WE GO
	LD	BC,SHORET	;MAKE A RETURN ADDRESS
	PUSH	BC
	JP	(HL)		;GO DO THE ROUTINE
SHORET	CALL	NEWLIN		;PRINT A NEW LINE
	JP	KERMIT		;GO GET A NEW COMMAND
;	SHOW JUMP TABLE
SHOJTB	JP	ECSTAT		;SHOW ESCAPE
	JP	ESTAT		;SHOW LOCAL ECHO
	JP	FSTAT		;SHOW WARNING
	JP	CSTAT		;SHOW FILE-MODE
	JP	CKSTAT		;SHOW BLOCK-CHECK-TYPE
	JP	VSTAT		;SHOW VT-52
	JP	PSTAT		;SHOW PRINTER
	JP	GSTAT		;SHOW DEBUGGING
	JP	DSTAT		;SHOW DEFAULT DISK
	JP	BSTAT		;BELL STATUS
	JP	BASTAT		;SHOW BAUD
	JP	IBSTAT		;SHOW IBM
	JP	PASTAT		;SHOW PARITY
	JP	RSTAT		;SHOW RECEIVE
	JP	SSTAT		;SHOW SEND
	JP	BKSTAT		;SHOW BACKSPACE
KYLEN	EQU	$-SHOJTB	;THESE 2 LINES MUST REMAIN TOGETHER
	JP	KYSTAT		;SHOW A KEY TRANSLATION
	JP	FLSTAT		;SHOW FLOW CONTROL
	JP	SHOINP		;SHOW INPUT PARAMETERS
	JP	SHOOTP		;SHOW OUTPUT PARAMETERS
	JP	TKSTAT		;SHOW STATUS OF TAKE DISPLAY
	JP	STAT01		;SHOW ALL
;	Print ON or OFF based on the status of the Accumulator
COFFON	LD	DE,OFFSTR	;START WITH OFF AS DEFAULT
	OR	A		;SET THE FLAGS
	JP	Z,PRTSTR	;GO PRINT OFF IF A ZERO
	LD	DE,ONSTR	;ELSE PRINT ON
	JP	PRTSTR
;	THIS IS THE STATUS COMMAND.
STATUS	LD	A,CMCFM		;GET A CONFIRM
	CALL	COMND
	JP	KERMT3		;QUIT ON AN ERROR
	CALL	STAT01		;GO PRINT ALL THE VALUES
	JP	KERMIT
;	Print the status of all settable values
STAT01	LD	DE,CLRTOP	;CLEAR THE SCREEN
	CALL	PRTSTR
	LD	DE,STHLP	;GET THE TOP OF SCREEN HEADER
	CALL	PRTSTR		;PRINT IT
	CALL	BSTAT
	CALL	ESTAT
	CALL	VSTAT
	CALL	CSTAT
	CALL	DSTAT
	CALL	FSTAT
	CALL	GSTAT
	CALL	PSTAT
	CALL	CKSTAT
	CALL	ECSTAT
	CALL	IBSTAT
	CALL	BKSTAT
	CALL	FLSTAT
	CALL	TKSTAT
	CALL	BASTAT
	CALL	PASTAT
	CALL	NEWLIN
	JP	NEWLIN		;PLUS ANOTHER
;	PRINT STATUS SUBROUTINES FOR EACH SETTABLE VALUE
TKSTAT	LD	DE,TAKST
	CALL	PRTSTR
	LD	A,(TAKLOG)
	CALL	COFFON
	RET
SHOINP	CALL	NEWLIN		;GET A NEW LINE
	LD	DE,CSEST	;GET CASE IGNORE STRING
	CALL	PRTSTR
	LD	A,(CSEFLG)
	CALL	COFFON
	LD	DE,IDSPST
	CALL	PRTSTR
	LD	A,(INDSP)
	CALL	COFFON
	RET
SHOOTP	LD	DE,HSTEST	;GET HOST ECHO STRING
	CALL	NEWLIN		;PRINT A NEW LINE
	CALL	PRTSTR
	LD	A,(ECHFLG)
	CALL	COFFON
	LD	DE,ODSPST
	CALL	PRTSTR
	LD	A,(OTDSP)
	CALL	COFFON
	CALL	NEWLIN
	RET
FLSTAT	LD	DE,FLOWST
	CALL	PRTSTR
	LD	DE,XONSTR
	LD	A,(FLOFLG)
	OR	A
	JR	NZ,FLST10
	LD	DE,NONSTR
FLST10	JP	PRTSTR
BKSTAT	LD	DE,BACKST	;PRINT THE STRING
	CALL	PRTSTR
	LD	A,(BCKCHR)	;GET WHAT IT IS
	LD	DE,BCKSPC	;GET THE BACKSPACE STRING
	CP	32		;IS IT LESS THAN A SPACE
	JP	P,BAST01	;GO IF IT ISN'T
	JP	PRTSTR		;PRINT WHAT IT IS
BAST01	LD	DE,BCKDEL	;GE THE DELETE STRING
	JP	PRTSTR
BASTAT	LD	DE,SPEDST
	CALL	PRTSTR
	RET
IBSTAT	LD	DE,IBMST
	CALL	PRTSTR
	LD	A,(IBMFLG)
	CALL	COFFON
	RET
PASTAT	LD	DE,PARST
	CALL	PRTSTR
	RET
DISSND	LD	DE,SENDST
	JP	PRTSTR
DISREC	LD	DE,RECST
	JP	PRTSTR
;	SHOW STATUS OF ALL SEND PARAMETERS
SSTAT	LD	A,CMCFM
	CALL	COMND
	JP	KERMT3
	CALL	NEWLIN
	CALL	DISSND
	LD	DE,EOLST
	CALL	PRTSTR
	LD	A,(SEOL)
	CALL	ANOUT
	CALL	DISSND
	LD	DE,PCHST
	CALL	PRTSTR
	LD	A,(SPADCH)
	CALL	ANOUT
	CALL	DISSND
	LD	DE,PADST
	CALL	PRTSTR
	LD	A,(SPAD)
	CALL	ANOUT
	CALL	DISSND
	LD	DE,QTEST
	CALL	PRTSTR
	LD	A,(SQUOTE)
	CALL	ESCPR1
	CALL	DISSND
	LD	DE,TOST
	CALL	PRTSTR
	LD	A,(STIME)
	CALL	ANOUT
	CALL	DISSND
	LD	DE,SOPST
	CALL	PRTSTR
	LD	A,(SSOHCH)
	CALL	ANOUT
	RET
;	SHOW STATUS OF ALL RECEIVE PARAMETERS
RSTAT	LD	A,CMCFM
	CALL	COMND
	JP	KERMT3
	CALL	NEWLIN
	CALL	DISREC
	LD	DE,EOLST
	CALL	PRTSTR
	LD	A,(REOL)
	CALL	ANOUT
	CALL	DISREC
	LD	DE,PCHST
	CALL	PRTSTR
	LD	A,(RPADCH)
	CALL	ANOUT
	CALL	DISREC
	LD	DE,PADST
	CALL	PRTSTR
	LD	A,(RPAD)
	CALL	ANOUT
	CALL	DISREC
	LD	DE,QTEST
	CALL	PRTSTR
	LD	A,(RQUOTE)
	CALL	ESCPR1
	CALL	DISREC
	LD	DE,TOST
	CALL	PRTSTR
	LD	A,(RTIME)
	CALL	ANOUT
	CALL	DISREC
	LD	DE,SOPST
	CALL	PRTSTR
	LD	A,(RSOHCH)
	CALL	ANOUT
	RET
BSTAT	LD	DE,BELSTR
	CALL	PRTSTR
	LD	A,(BELFLG)	;GET THE FLAG
	JP	COFFON		;PRINT THE STATUS
ESTAT	LD	DE,LOCST	;GET THE HEADER TO PRINT
	CALL	PRTSTR		;PRINT IT
	LD	A,(ECOFLG)	; GET THE LOCAL ECHO FLAG.
	JP	COFFON
VSTAT	LD	DE,VTEMST	; GET THE VT52 EMULATION STRING.
	CALL	PRTSTR
	LD	A,(VTFLG)
	JP	COFFON
CSTAT	LD	DE,CPMST	; GET THE MESSAGE
	CALL	PRTSTR
	LD	DE,DEFSTR	;GET THE DEFAULT MESSAGE
	LD	A,(CPMFLG)	;CHECK THE STATUS
	OR	A		; IS IT ON?
	JR	Z,STAT21	; IF NOT SAY SO.
	CP	1		; ASCII?
	LD	DE,ASCSTR
	JR	Z,STAT21	; SAY ASCII
	LD	DE,BINSTR	; SAY BINARY
STAT21	JP	PRTSTR		; PRINT WHAT IS IN DE
DSTAT	LD	DE,DSKDEF	;GET THE MESSAGE
	CALL	PRTSTR		;PRINT IT
	CALL	STDOUT		;REVERSE VIDEO ON
	LD	A,(DEFDSK)	;GET THE CHARACTER 0-9
	CALL	CONOUT
	JP	STDEND		;REVERSE VIDEO OFF
FSTAT	LD	DE,FILST	; FILE WARNING STRING.
	CALL	PRTSTR
	LD	A,(FLWFLG)	;GET THE STATUS
	JP	COFFON		;GO PRINT THE STATUS
GSTAT	LD	DE,BUGST	;debug string
	CALL	PRTSTR
	LD	A,(DBFLG)	;GET THE STATUS
	JP	COFFON		;PRINT THE STATUS
PSTAT	LD	DE,PNTSTR	;printer string
	CALL	PRTSTR
	LD	A,(PRTFLG)	;get printer flag
	JP	COFFON		;GO PRINT IT
CKSTAT	LD	DE,BCKST	; GET THE STRING
	CALL	PRTSTR		; PRINT "BLOCK CHECK TYPE "
	CALL	STDOUT		;REVERSE VIDEO ON
	LD	A,(CHKTYP)	; GET THE TYPE (CHARACTER 1, 2, OR 3)
	CALL	CONOUT
	CALL	STDEND		;REVERSE VIDEO OFF
	LD	DE,BCKST1	; GET REST OF TEXT ("-CHARACTER")
	JP	PRTSTR		;  .  .  .
ECSTAT	LD	DE,ESCST	; ESCAPE STRING.
	CALL	PRTSTR
	CALL	STDOUT		;REVERSE VIDEO ON
	CALL	ESCPR		; PRINT THE ESCAPE CHAR.
	JP	STDEND		;REVERSE VIDEO OFF
LOGONE	PUSH	AF
	PUSH	DE
	LD	E,A
	LD	A,(LOGFLG)
	OR	A
	LD	A,E
	CALL	NZ,LOGIT
	POP	DE
	POP	AF
	RET
