;	M4MORE/ASM
; THIS IS WHERE WE GO IF WE GET AN ERROR DURING A PROTOCOL COMMUNICATION.
; CALL ERROR PRINTS THE ERROR PACKET ON LINE 6 OR SO.
; CALL ERROR1 PRINT CRLF FOLLOWED BY THE ERROR PACKET.
; CALL ERROR2 JUST PRINTS THE ERROR PACKET.
; CALL ERROR3 POSITIONS CURSOR AND PRINTS ERROR MESSAGE SPECIFIED IN DE.
; 31 MAR 86 DAVORK SUPPORT FOR STRIP-EIGHTH-BIT
ERROR	CALL	ERROR9		; POSITION THE CURSOR.
	LD	A,'A'		; SET THE STATE TO ABORT.
	LD	(STATE),A
	JP	ERROR2
ERROR1	LD	DE,CRLF		; PRINT A CRLF.
	CALL	PRTSTR
ERROR2	LD	A,(ARGBLK+1)	; GET THE LENGTH OF THE DATA.
	LD	C,A
	LD	B,0		; PUT IT INTO BC
	LD	HL,DATA		; GET THE ADDRESS OF THE DATA.
	ADD	HL,BC		; GET TO THE END OF THE STRING.
	LD	A,'$'		; PUT A DOLLAR SIGN AT THE END.
	LD	(HL),A
	LD	DE,DATA		; PRINT ERROR MESSAGE
	CALL	PRTSTR
	RET	
ERROR3	PUSH	DE		; SAVE THE POINTER TO THE MESSAGE.
	CALL	ERROR9		; POSITION THE CURSOR.
	LD	DE,CLRLIN	; CLEAR THE LINE
	CALL	PRTSTR
	POP	DE		; GET THE POINTER BACK.
	CALL	PRTSTR		; PRINT ERROR MESSAGE
	RET	
ERROR9	LD	DE,SCRERR	; POSITION CURSOR
	CALL	PRTSTR
	RET	
ERRORD	OR	A		;display disk error
	RET	Z
	CALL	XERROR
	RET
FINMES	PUSH	DE		; SAVE MESSAGE.
	LD	DE,SCRST
	CALL	PRTSTR
	POP	DE		; PRINT THE TERMINATION MESSAGE
	CALL	PRTSTR
	LD	DE,SCREND	; POSITION CURSOR FOR PROMPT
	CALL	PRTSTR
	RET	
; THIS IS THE FINISH COMMAND.	IT TELLS THE REMOTE KERSRV TO EXIT.
FINISH	LD	A,CMCFM
	CALL	COMND		; GET A CONFIRM.
	JP	KERMT3
	CALL	CLRPRT		; CLEAR ANY STACKED NAKS
	XOR	A		;  DIDN'T GET A CONFIRM.
	LD	(NUMTRY),A	; INITITIALIZE COUNT.
	LD	A,'1'		; RESET BLOCK CHECK TYPE TO SINGLE CHARACTER
	LD	(CURCHK),A	;  .  .  .
FINSH1	LD	A,(NUMTRY)	; HOW MANY TIMES HAVE WE TRIED?
	CP	MAXTRY		; TOO MANY TIMES?
	JP	M,FINSH3	; NO, TRY IT.
FINSH2	LD	DE,ERMS18	; SAY WE COULDN'T DO IT.
	CALL	PRTSTR
	JP	LOG111		; GO HOME.
FINSH3	INC	A		; INCREMENT THE NUMBER OF TRIES.
	LD	(NUMTRY),A
	XOR	A
	LD	(ARGBLK),A	; MAKE IT PACKET NUMBER ZERO.
	LD	A,1
	LD	(ARGBLK+1),A	; ONE PIECE OF DATA.
	LD	HL,DATA
	LD	(HL),'F'	; FINISH RUNNING KERMIT.
	LD	A,'G'		; GENERIC COMMAND PACKET.
	CALL	SPACK
	JP	FINSH1
	CALL	RPACK	 	;GET AN ACKNOWLEDGEMENT.
	JP	FINSH1
	CP	'Y'		; ACK?
	JP	Z,KERMIT	; YES, WE ARE DONE.
	CP	'E'		; IS IT AN ERROR PACKET?
	JP	NZ,FINSH1	; TRY SENDING THE PACKET AGAIN.
	CALL	ERROR1		; PRINT THE ERROR MESSAGE.
	JP	KERMIT
; THIS IS THE LOGOUT COMMAND.	IT TELLS THE REMOTE KERSRV TO LOGOUT.
LOGOUT	LD	A,CMCFM
	CALL	COMND		; GET A CONFIRM.
	JP	KERMT3
	CALL	LOGO		; SEND THE LOGOUT PACKET.
	JP	LOG111		; GO GET ANOTHER COMMAND
	JP	KERMIT		;  WHETHER WE SUCCEED OR NOT.
LOGO	XOR	A
	LD	(NUMTRY),A	; INITITIALIZE COUNT.
	CALL	CLRPRT		; CLEAR ANY STACKED NAKS
	LD	A,'1'		; RESET BLOCK CHECK TYPE TO SINGLE CHARACTER
	LD	(CURCHK),A	;  .  .  .
LOGO1	LD	A,(NUMTRY)	; HOW MANY TIMES HAVE WE TRIED?
	CP	MAXTRY		; TOO MANY TIMES?
	JP	M,LOGO3		; NO, TRY IT.
LOGO2	LD	DE,ERMS19	; SAY WE COULDN'T DO IT.
	CALL	PRTSTR
	RET			; FINISHED.
LOGO3	INC	A		; INCREMENT THE NUMBER OF TRIES.
	LD	(NUMTRY),A
	XOR	A
	LD	(ARGBLK),A	; MAKE IT PACKET NUMBER ZERO.
	LD	A,1
	LD	(ARGBLK+1),A	; ONE PIECE OF DATA.
	LD	HL,DATA
	LD	(HL),'L'	; LOGOUT THE REMOTE HOST.
	LD	A,'G'		; GENERIC COMMAND PACKET.
	CALL	SPACK
	JP	LOGO2
	CALL	RPACK		; GET AN ACKNOWLEDGEMENT
	JP	LOGO1
	CP	'Y'		; ACK?
	JP	Z,RSKP		; YES, WE ARE DONE.
	CP	'E'		; IS IT AN ERROR PACKET?
	JP	NZ,LOGO1	; TRY SENDING THE PACKET AGAIN.
	CALL	ERROR1		; PRINT THE ERROR MESSAGE.
	RET			; ALL DONE.
; THIS IS THE BYE COMMAND.	IT TELLS THE REMOTE KERSRV TO LOGOUT AND EXITS.
BYE	LD	A,CMCFM
	CALL	COMND		; GET A CONFIRM.
	JP	KERMT3
	CALL	LOGO		; TELL THE MAIN FRAME TO LOGOUT.
	JP	LOG111		; IF IT FAILS, DON'T EXIT.
	JP	EXIT1		; EXIT KERMIT.
LOG111	CALL	NEWLIN		; GET A NEW LINE
	JP	KERMIT
; THIS IS THE LOG COMMAND.  IT LOGS A SESSION TO A FILE.
LOG	LD	A,(LOGFLG)	; CHECK IF WE ARE ALREADY LOGGING
	OR	A
	JR	Z,LOGOK
	LD	DE,LOGOPN	; PRINT MESSAGE THAT LOG FILE IS OPEN
	CALL	PRTSTR
	JP	KERMIT		; RETURN TO COMMAND PARSER
LOGOK	LD	A,CMIFI		; PARSE AN INPUT FILE SPEC.
	LD	DE,LFCB
	CALL	COMND
	JP	KERMT3
	LD	A,2H		;set the logging flag
	LD	(LOGFLG),A	;WITH WRITE ENABLED
	LD	HL,LBUFF
	LD	DE,LFCB
	LD	B,0
LOG1A	CALL	XINIT
	JP	Z,KERMIT	; QUIT IF IT DID WORK
	PUSH	AF		;SAVE THE ERROR AND THE FLAGS
	XOR	A		;RESET THE LOGGING FLAG
	LD	(LOGFLG),A	
	POP	AF		;RESTORE THE ERROR
	CALL	XERROR		;PRINT AN ERROR
	JP	KERMIT		;GET A NEW COMMAND
;this is the connect command
TELNET	LD	A,CMCFM
	CALL	COMND
	JP	KERMT3
	LD	DE,CLRTOP
	CALL	PRTSTR
TELE1	LD	DE,INFMS7
	CALL	PRTSTR
	CALL	ESCPR
	LD	DE,INFMS8
	CALL	PRTSTR
CHRLUP	XOR	A
	LD	(CHCNT),A
	CALL	PRTCHR
	CALL	CONCHR
	JP	KERMIT
	JP	CHRLUP
INPORT	PUSH	HL		;SAVE HL
	LD	HL,(NXTCHR)	;GET THE ADDRESS OF NEXT
	LD	A,(CURCHR)	;GET THE LSB OF THE CURRENT
	CP	L		;CHECK FOR NONE THERE
	JR	Z,INOUT		;NONE IF EQUAL
	LD	A,(FLOFLG)	;ARE WE DOING FLOW-CONTROL?
	OR	A		;SET THE FLAGS
	LD	A,(HL)		;GET THE CHARACTER IN CASE WE AREN'T
	JR	Z,INP11		;GO IF WE AREN'T DOING FLOW CONTROL
	DI			;INTERRUPT OFF FOR NOW
	LD	(SVCHAR),A	;SAVE THE CHARACTER FOR NOW
	INC	L
	LD	(NXTCHR),HL
	LD	A,(INCNT)	;DECREMENT THE COUNT
	DEC	A
	LD	(INCNT),A	;STORE IT BACK
	EI			;INTERRUPTS BACK ON
	PUSH	BC		;SAVE C
	LD	C,A		;GET A COPY OF THE COUNT
	LD	A,(XFFLG)	;CHECK IF XOFF SENT
	OR	A		;IS THE FLAG ON
	JR	Z,INP10		;GO IF NOT
	LD	A,100		;CHECK IF TIME FOR XON
	CP	C		;IS 100 >= COUNT
	JP	M,INP10		;GO IF STILL TOO MANY LEFT
	PUSH	DE		;SAVE E FOR XON
	LD	E,XON		;GET IT
	CALL	OUTCHR		;SEND AN XON
	XOR	A		;RESET THE FLAG
	LD	(XFFLG),A	; ZERO
	POP	DE		;RESTORE DE
INP10	POP	BC		;RESTORE OLD BC
	LD	A,(SVCHAR)	;GET THE NEXT CHARACTER
INP11	CP	A		;SET Z STATUS
INOUT1	POP	HL		;RESTORE HL
	RET
INOUT	INC	L		;NOW A & L ARE NOT EQUAL
	CP	L		;SET NZ STATUS
	PUSH	AF		;SAVE THE FLAGS
	XOR	A		;SAY NO CHARACTERS AVAILABLE
	LD	(INCNT),A
	POP	AF
	POP	HL		;RESTORE STACK
	RET
SVCHAR	DB	0
PRTCHR	CALL	INPORT
	RET	NZ
	CP	32
	JR	NC,T1
	LD	HL,TRTAB	;GET THE TRANSLATION TABLE
	LD	C,A		;PUT THE CHARACTER IN C
	LD	B,0		;MAKE BC AN OFFSET INTO TABLE
	ADD	HL,BC		;CALCULATE THE ADDRESS
	LD	A,(HL)		;GET THE NEW CHAR IN A
	OR	A		;IGNORE NULLS
	RET	Z
	CP	12		;IS IT A FORMFEED
	JP	Z,CMBLNK	;GO BLANK THE SCREEN
T1	LD	E,A		;SAVE THE CHARACTER
	LD	A,(VTFLG)	;CHECK FOR VT53 EMULATION
	OR	A		;SET THE FLAGS
	JR	Z,PRTCH1	;GO IF NOT VT52 MODE
	LD	A,(ESCFLG)	;CHECK IF ESCAPE FLAG SET
	OR	A		;SET THE FLAGS
	LD	A,E		;GET A COPY
	JP	NZ,VT52		;GO IF IT IS
	CP	ESC		;IS THIS ONE ESCAPE?
	JR	NZ,PRTCH1	;JUMP IF NOT
	LD	(ESCFLG),A	;SET THE FLAG WITH NON-ZERO
	JP	PRTCHR
PRTCH1	LD	A,E		;GET THE CHARACTER
	CALL	LOGONE		;CHECK FLAG ELSE WHERE
	LD	A,(PRTFLG)	;CHECK FOR PRINTER OUTPUT
	OR	A		;SET THE FLAGS
	CALL	NZ,PRTIT	;GO PRINT IT
	LD	A,E		;GET THE CHARACTER AND DISPLAY
	CALL	CONOUT		;PRINT IT ON THE SCREEN
	LD	A,(CHCNT)	;CHECK CHARACTER COUNT
	LD	B,A		;GET IT IN B
	DJNZ	CHK002		;SKIP RETURN IF NOT LIMIT
	RET			;RETURN AFTER LIMIT IS UP
CHK002	LD	A,B		;GET THE NEW COUNT
	LD	(CHCNT),A	;SAVE IT
	JP	PRTCHR		;LOOP ON
CONCHR	CALL	CONIN		;GET A KEYBOARD CHARACTER
	OR	A
	JP	Z,RSKP		;RETURN IF NONE FOUND
	PUSH	HL		;DO "SET KEY" TRANSLATIONS
	LD	HL,TRNCON
	PUSH	BC
	LD	C,A
	LD	B,0
	ADD	HL,BC
	LD	A,(HL)
	POP	BC
	POP	HL
	LD	E,A		;IS IT THE ESCAPE CHARACTER?
	LD	A,(ESCCHR)
	CP	E
	JP	Z,INTCHR
	LD	A,E
;	CALL	LOGONE
	LD	A,(VTFLG)
	OR	A
	JR	Z,NOVT52
	LD	A,E
	CP	136		;MAP CLEAR ARROWS TO VT52'S ARROW KEYS
	JP	M,NOVT52	;NOT CLEAR LEFT ARROW OR BIGGER
	CP	140		;CHECK CLEAR UP ARROW
	JP	P,NOVT52	;GREATER THE CLEAR UP ARROW
	LD	A,ESC		;GET AN ESCAPE FOR THE 2 CHAR SEQ
	PUSH	DE
	CALL	PRTOUT		;SEND IT OUT THE PORT
	POP	DE
	LD	A,E		;GET THE REAL CHARACTER
	LD	B,0		;GET READY TO LOOK IT UP
	SUB	136		;MAKE A AN OFFSET INTO THE TABLE
	LD	C,A		;BC IS NOW THE OFFSET
	LD	HL,VTTAB1	;GET THE LOOKUP TABLE
	ADD	HL,BC
	LD	A,(HL)		;GET THE ACTUAL CHARACTER
	JR	VTGO
NOVT52	LD	A,E
VTGO	PUSH	DE		;SAVE DE
	CALL	PRTOUT		;SEND IT TO THE PORT
NOESC	POP	DE
	LD	A,(ECOFLG)	;CHECK FOR LOCAL ECHO
	OR	A
	JP	Z,RSKP		;RETURN IF NO ECHO NEEDED
	LD	A,E
	AND	7FH		;NOW TRUNCATE TO 7 BITS
	CALL	CONOUT
	JP	RSKP		;RETURN TO THE CALLER SAY OK
INTCHR	CALL	CONIN		;GET A CHARACTER
	OR	A
	JR	Z,INTCHR
	LD	B,A
	AND	137O
	CP	'C'		;is it close?
	JP	NZ,INTCHR0	;no
	LD	DE,INFMS9
	CALL	PRTSTR
	RET
INTCHR0	CP	'S'		;status?
	JR	NZ,INCH01
	CALL	STAT01		;print out status
	JP	RSKP
INCH01	LD	A,B
	CP	'?'
	JR	NZ,INTCH1
	LD	DE,INTHLP
	CALL	PRTSTR
	JP	INTCHR
INTCH1	CALL	CAPTAL
	CP	'B'
	JR	NZ,INTCH2
	LD	C,1		;OPTION 1 OF @CTL
	LD	A,5		;@CTL SVC
	RST	28H		;CALL IT
	LD	BC,5000		;WAIT FOR A SEC
	LD	A,16		;@PAUSE SVC
	RST	28H		;WAITING
	LD	E,0		;SEND A NULL TO RESET BREAK
	CALL	OUTCHR		;OUT THE PORT WITH IT
	JP	RSKP
INTCH2	LD	A,B
	CP	'0'
	JR	NZ,INTCH3
	LD	E,0
	CALL	OUTCHR
	JP	RSKP
INTCH3	LD	E,B
	LD	A,(ESCCHR)
	CP	E
	JR	Z,INTCHZ
	LD	A,B
	CALL	CAPTAL
	CP	'Q'		; QUIT LOGGING?
	JR	NZ,INTCH4
	LD	A,(LOGFLG)
	CP	2		; SEE IF WE CAN TURN LOGGING OFF
	JR	NZ,INTC3A
	DEC	A
	LD	(LOGFLG),A
	JP	RSKP
INTC3A	LD	A,BELL
	CALL	CONOUT		; BEEP AT THEM
	JP	RSKP
INTCH4	CP	'R'
	JR	NZ,INTCH5
	LD	A,(LOGFLG)
	CP	1
	JR	NZ,INTC3A
	INC	A
	LD	(LOGFLG),A
	JP	RSKP
INTCH5	LD	A,E
	CALL	PRTOUT
	JP	RSKP
INTCHZ	CALL	OUTCHR		;SEND IT OUT THE PORT
	LD	A,BELL
	CALL	CONOUT
	JP	RSKP
PRTIT	IN	A,(0F8H)	;get printer status
	AND 	0F0H
	CP	30H
	RET	NZ		;skip this one
	LD	A,E
	PUSH	DE
	CALL	XPRT		;dos printer routine
	POP	DE
	RET
PRTOUT	OR	A
	RET	Z
	LD	E,A
	CALL	OUTCHR
	RET

